class SystemLogger {

  constructor() {
    this.errorsPersistedInFiles = ['DB_ERROR'];
  }
  

  error(error) {
    if(!error) error = 'Ocorreu um erro inesperado. Parâmetro "error" não especificado';
    const err = typeof error === 'string' ? new Error(error) : error;
    if(this.errorsPersistedInFiles.includes(err.message)) return;
    console.error(err.message);
  }

  log(text) {
    console.log(text);
  }
}

module.exports = new SystemLogger();