const fs = require("fs");
const path = require("path");
const admZip = require("adm-zip");
const moment = require("moment");
require("moment/locale/pt-br");

const adqSrvInsConsumidor = require("../model/adqSrvInsConsumidorModel");
const adqVerifConsumidor = require("../model/adqVerifConsumidorModel");
const adqSrvUpdConsumidor = require("../model/adqSrvUpdConsumidorModel");
const adqSrvUpdOperador = require("../model/adqSrvUpdOperadorModel");
const qryAtualizaMoviClie = require("../model/qryAtualizaMoviClieModel");
const acmUpdMoviClie = require("../model/acmUpdMoviClieModel");
const adqSrvExtratoCons = require("../model/adqSrvExtratoConsModel");
const adqMinDtMovExtCons = require("../model/adqMinDtMovExtConsModel");
const acmUpdExtratoCons = require("../model/acmUpdExtratoConsModel");
const adqUltMovExt = require("../model/adqUltMovExtModel");
const adqMovExtrato = require("../model/adqMovExtratoModel");
const acmUpMovExtrato = require("../model/acmUpMovExtratoModel");
const adqVerifSaldFami = require("../model/adqVerifSaldFamiModel");
const acmInsSaldFami = require("../model/acmInsSaldFamiModel");
const acmUpSaldo = require("../model/acmUpSaldoModel");
const adqVerifVenda = require("../model/adqVerifVendaModel");
const adqValidaEstorno = require("../model/adqValidaEstornoModel");
const adqVerificaNOVOCODNFCE = require("../model/adqVerificaNOVOCODNFCEModel");
const acmDelNOVOCODNFCE = require("../model/acmDelNOVOCODNFCEModel");
const adqVerificaRedZ = require("../model/adqVerificaRedZModel");
const adqVerifTurCaixa = require("../model/adqVerifTurCaixaModel");
const adqVerifLogOperFos = require("../model/adqVerifLogOperFosModel");
const adqVerifLogAcesso = require("../model/adqVerifLogAcessoModel");
const adqVerifControlSenha = require("../model/adqVerifControlSenhaModel");
const adqVerifInutilizaNfce = require("../model/adqVerifInutilizaNfceModel");
const adqVerifPedidoFos = require("../model/adqVerifPedidoFosModel");
const adqVerifArqCat52 = require("../model/adqVerifArqCat52Model");
const adqVerifMovCaixa = require("../model/adqVerifMovCaixaModel");
const adqArqCat52 = require("../model/adqArqCat52Model");
const adqVerifItComandaPend = require("../model/adqVerifItComandaPendModel");
const acmDelItComandaPend = require("../model/acmDelItComandaPendModel");
const adqMoviClie = require("../model/adqMoviClieModel");
const acmUpdUltMoviClie = require("../model/acmUpdUltMoviClieModel");
const acmUpdSaldoMoviClie = require("../model/acmUpdSaldoMoviClieModel");
const acmUpdMovCaixa = require("../model/acmUpdMovCaixaModel");
const adqVerifMovBeneficioCtr = require("../model/adqVerifMovBeneficioCtrModel");
const acmUpdMovBeneficioCtr = require("../model/acmUpdMovBeneficioCtrModel");
const acmCancMovCaixa = require("../model/acmCancMovCaixaModel");
const adqVerificaCDSERIECX = require("../model/adqVerificaCDSERIECXModel");
const adqVerifRelVendas = require("../model/adqVerifRelVendasModel");
const adqQtdeVendasOracle = require("../model/adqQtdeVendasOracleModel");
const acmInsRelVendas = require("../model/acmInsRelVendasModel");
const acmUpdRelVendas = require("../model/acmUpdRelVendasModel");
const acmApagaVendasDup = require("../model/acmApagaVendasDupModel");
const adqVerificaEmissCaixa = require("../model/adqVerificaEmissCaixaModel");
const acmCorrigeICMS = require("../model/acmCorrigeICMSModel");
const acmCorrigePIS = require("../model/acmCorrigePISModel");
const acmCorrigeCOFINS = require("../model/acmCorrigeCOFINSModel");
const adqMovBeneficioCons = require("../model/adqMovBeneficioConsModel");
const acmUpdCancMovBeneficio = require("../model/acmUpdCancMovBeneficioModel");
const acmApagaSangriaDup = require("../model/acmApagaSangriaDupModel");
const acmUpdNrSeqVenda = require("../model/acmUpdNrSeqVendaModel");
const adqVerifLogSincDlv = require("../model/adqVerifLogSincDlvModel");
const adqSrvTotalDiaCaixa = require("../model/adqSrvTotalDiaCaixaModel");
const adqVerifTotalDiaCaixa = require("../model/adqVerifTotalDiaCaixaModel");
const qryGetNextNrSeqVendaModel = require("../model/qryGetNextNrSeqVendaModel");
const ClientDataSet = require("../components/ClientDataSet");
const ConstructQuery = require("../functions/ConstructQuery");
const TransfDados = require("../modules/TransfDados");
const InfoLogger = require("../logs/InfoLogger");
const OracleService = require("./OracleService");
const adqMinDtUltAtuExtModel = require("../model/adqMinDtUltAtuExtModel");
const adqMaxDtuUltAtuMCLIModel = require("../model/adqMaxDtuUltAtuMCLIModel");
const insereConsumidorModel = require("../model/insereConsumidorModel");
const insereExtratoConsModel = require("../model/insereExtratoConsModel");
const GeraNovoCodigo = require("../modules/NovoCodigoModule");
const editaVendaModel = require("../model/editaVendaModel");
const adqVerifConsumidorModel = require("../model/adqVerifConsumidorModel");
const adqVerifTotalDiaCaixaSinc = require("../model/adqVerifTotalDiaCaixaSincModel");
const adqVerifItemVenda = require("../model/adqVerifItemVenda");
const adqVerifItHrComanda = require("../model/adqItHrComanda");
const adqVerifItVendaImpos = require("../model/adqVerifItVendaImpos");
const adqVerifEndeCons = require("../model/adqVerifEndeCons");
const adqVerifProdBloqVndTaa = require("../model/adqVerifProdBloqVndTaa");

const cdsRetTurCaixa = new ClientDataSet([]);
const cdsRetLogOperFos = new ClientDataSet([]);
const cdsRetLogAcesso = new ClientDataSet([]);
const cdsRetVenda = new ClientDataSet([]);
const cdsRetMovCaixa = new ClientDataSet([]);
const cdsRetPedidoFos = new ClientDataSet([]);

const Now = () => {
  return moment(new Date()).format("Y-MM-DD HH:mm:ss");
};
const DateFormat = (data) => {
  let dataFormatada;

  try {
    dataFormatada =
      data !== null ? moment(data).utc().format("Y-MM-DD HH:mm:ss") : null;
  } catch (error) {
    console.log("Erro na formatação da data: ", data);
  }

  return dataFormatada;
};

class UpDataService {
  async setInsereServidor(P_CDFILIAL, P_CDCAIXA, P_CDLOJA, P_OLERESULT) {
    const cdsVendaTemp = new ClientDataSet([]);
    const cdsMovCaixaTemp = new ClientDataSet([]);
    const cdsPedidoFosTemp = new ClientDataSet([]);

    InfoLogger.write(
      `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - INICIO`,
      P_CDFILIAL
    );

    const OleResult = P_OLERESULT;
    // Usado para salvar log nas funções que não tem parâmetro de filial
    const stCdFilialAux = P_CDFILIAL;
    // Usado para salvar log nas funções que não tem parâmetro de caixa
    const stCdCaixaAux = P_CDCAIXA;

    let cdsCliRelVendas = null;
    let cdsCliVenda = null;
    let cdsCliMovCaixa = null;
    let existeTurCaixa = null;

    try {
      try {
        const cdsCliConsumidor = new ClientDataSet(OleResult[0]["DATA"]);
        cdsCliConsumidor.tabela = OleResult[0]["TABLENAME"];

        const cdsCliOperador = new ClientDataSet(OleResult[1]["DATA"]);
        cdsCliOperador.tabela = OleResult[1]["TABLENAME"];

        const cdsLOGOPERFOS = new ClientDataSet(OleResult[2]["DATA"]);
        cdsLOGOPERFOS.tabela = OleResult[2]["TABLENAME"];

        const cdsCliLOGACESSO = new ClientDataSet(OleResult[3]["DATA"]);
        cdsCliLOGACESSO.tabela = OleResult[3]["TABLENAME"];

        const cdsCliControlSenha = new ClientDataSet(OleResult[4]["DATA"]);
        cdsCliControlSenha.tabela = OleResult[4]["TABLENAME"];

        const cdsCliINUTILIZANFCE = new ClientDataSet(OleResult[5]["DATA"]);
        cdsCliINUTILIZANFCE.tabela = OleResult[5]["TABLENAME"];

        const cdsCliITCOMANDAPEND = new ClientDataSet(OleResult[6]["DATA"]);
        cdsCliITCOMANDAPEND.tabela = OleResult[6]["TABLENAME"];

        const cdsCliPedidoFos = new ClientDataSet(OleResult[7]["DATA"]);
        cdsCliPedidoFos.tabela = OleResult[7]["TABLENAME"];

        const cdsCliItPedidoFos = new ClientDataSet(OleResult[8]["DATA"]);
        cdsCliItPedidoFos.tabela = OleResult[8]["TABLENAME"];

        const cdsCliNOVOCODNFCE = new ClientDataSet(OleResult[9]["DATA"]);
        cdsCliNOVOCODNFCE.tabela = OleResult[9]["TABLENAME"];

        const cdsCliARQCAT52 = new ClientDataSet(OleResult[10]["DATA"]);
        cdsCliARQCAT52.tabela = OleResult[10]["TABLENAME"];

        const cdsCliReducaoZ = new ClientDataSet(OleResult[11]["DATA"]);
        cdsCliReducaoZ.tabela = OleResult[11]["TABLENAME"];

        const cdsCliIMPOSTOREDZ = new ClientDataSet(OleResult[12]["DATA"]);
        cdsCliIMPOSTOREDZ.tabela = OleResult[12]["TABLENAME"];

        const cdsCliTOTNFISCREDZ = new ClientDataSet(OleResult[13]["DATA"]);
        cdsCliTOTNFISCREDZ.tabela = OleResult[13]["TABLENAME"];

        const cdsCliFORMPGTOREDZ = new ClientDataSet(OleResult[14]["DATA"]);
        cdsCliFORMPGTOREDZ.tabela = OleResult[14]["TABLENAME"];

        const cdsCliTurCaixa = new ClientDataSet(OleResult[15]["DATA"]);
        cdsCliTurCaixa.tabela = OleResult[15]["TABLENAME"];

        cdsCliVenda = new ClientDataSet(OleResult[16]["DATA"]);
        cdsCliVenda.tabela = OleResult[16]["TABLENAME"];

        const cdsCliExtratoCons = new ClientDataSet(OleResult[17]["DATA"]);
        cdsCliExtratoCons.tabela = OleResult[17]["TABLENAME"];

        const cdsCliItemVenda = new ClientDataSet(OleResult[18]["DATA"]);
        cdsCliItemVenda.tabela = OleResult[18]["TABLENAME"];

        const cdsCliItVendaImpos = new ClientDataSet(OleResult[19]["DATA"]);
        cdsCliItVendaImpos.tabela = OleResult[19]["TABLENAME"];

        const cdsCliItVendaCan = new ClientDataSet(OleResult[20]["DATA"]);
        cdsCliItVendaCan.tabela = OleResult[20]["TABLENAME"];

        const cdsCliITEMVENDAEST = new ClientDataSet(OleResult[21]["DATA"]);
        cdsCliITEMVENDAEST.tabela = OleResult[21]["TABLENAME"];

        cdsCliMovCaixa = new ClientDataSet(OleResult[22]["DATA"]);
        cdsCliMovCaixa.tabela = OleResult[22]["TABLENAME"];

        const cdsCliMoviClie = new ClientDataSet(OleResult[23]["DATA"]);
        cdsCliMoviClie.tabela = OleResult[23]["TABLENAME"];

        const cdsCliEstornoVnd = new ClientDataSet(OleResult[24]["DATA"]);
        cdsCliEstornoVnd.tabela = OleResult[24]["TABLENAME"];

        const cdsCliItFidelidade = new ClientDataSet(OleResult[25]["DATA"]);
        cdsCliItFidelidade.tabela = OleResult[25]["TABLENAME"];

        const cdsCliMovBeneficioCons = new ClientDataSet(OleResult[26]["DATA"]);
        cdsCliMovBeneficioCons.tabela = OleResult[26]["TABLENAME"];

        const cdsCliMovBeneficioCtr = new ClientDataSet(OleResult[27]["DATA"]);
        cdsCliMovBeneficioCtr.tabela = OleResult[27]["TABLENAME"];

        const cdsCliObsItemVenda = new ClientDataSet(OleResult[28]["DATA"]);
        cdsCliObsItemVenda.tabela = OleResult[28]["TABLENAME"];

        const cdsCliObsItemVendaEst = new ClientDataSet(OleResult[29]["DATA"]);
        cdsCliObsItemVendaEst.tabela = OleResult[29]["TABLENAME"];

        const cdsCliItHrComanda = new ClientDataSet(OleResult[30]["DATA"]);
        cdsCliItHrComanda.tabela = OleResult[30]["TABLENAME"];

        cdsCliRelVendas = new ClientDataSet(OleResult[31]["DATA"]);
        cdsCliRelVendas.tabela = OleResult[31]["TABLENAME"];

        const cdsCliItVendaDes = new ClientDataSet(OleResult[32]["DATA"]);
        cdsCliItVendaDes.tabela = OleResult[32]["TABLENAME"];

        const cdsCliExtratoConsPend = new ClientDataSet(OleResult[33]["DATA"]);
        cdsCliExtratoConsPend.tabela = OleResult[33]["TABLENAME"];

        const cdsCliUsoCupomDescFos = new ClientDataSet(OleResult[34]["DATA"]);
        cdsCliUsoCupomDescFos.tabela = OleResult[34]["TABLENAME"];

        const cdsCliLogSincDlv = new ClientDataSet(OleResult[35]["DATA"]);
        cdsCliLogSincDlv.tabela = OleResult[35]["TABLENAME"];

        const cdsCliTotalDiaCaixa = new ClientDataSet(OleResult[36]["DATA"]);
        cdsCliTotalDiaCaixa.tabela = OleResult[36]["TABLENAME"];

        const cdsCliProdBloqVndTaa = new ClientDataSet(OleResult[37]["DATA"]);
        cdsCliProdBloqVndTaa.tabela = OleResult[37]["TABLENAME"];

        const cdsCliEndeCons = new ClientDataSet(OleResult[38]["DATA"]);
        cdsCliEndeCons.tabela = OleResult[38]["TABLENAME"];

        const cdsCliLogNfce = new ClientDataSet(OleResult[39]["DATA"]);
        cdsCliLogNfce.tabela = OleResult[39]["TABLENAME"];

        const cdsCliKdsTempSetorEst = new ClientDataSet(OleResult[40]["DATA"]);
        cdsCliKdsTempSetorEst.tabela = OleResult[40]["TABLENAME"];

        const cdsCliPromoVenda = new ClientDataSet(OleResult[41]["DATA"]);
        cdsCliPromoVenda.tabela = OleResult[41]["TABLENAME"];

        // // { ---------------------------- INÍCIO CONSISTÊNCIAS ---------------------------- }

        this.ConsisteTurCaixa();
        this.ConsisteVenda();
        this.ConsisteMovCaixa();
        await this.consisteExtratoCons(
          cdsCliExtratoCons,
          cdsCliTurCaixa,
          cdsCliVenda
        );

        await this.consisteReducaoZ(
          cdsCliReducaoZ,
          cdsCliIMPOSTOREDZ,
          cdsCliTOTNFISCREDZ,
          cdsCliFORMPGTOREDZ
        );

        await this.consisteArqCat52(cdsCliARQCAT52);
        await this.consisteControlSenha(cdsCliControlSenha);
        try {
          await this.consisteItComandaPend(
            P_CDFILIAL,
            P_CDLOJA,
            cdsCliITCOMANDAPEND
          );
        } catch (error) {
          console.log(error);
        }
        cdsCliINUTILIZANFCE.data = await this.consisteInutilizaNfce(
          cdsCliINUTILIZANFCE
        );
        this.ConsisteItHrComanda();
        await this.consisteLogSincDlv(cdsCliLogSincDlv, P_CDFILIAL);
        await this.ConsisteEndeCons(cdsCliEndeCons, P_CDFILIAL);

        existeTurCaixa = cdsCliTurCaixa.data.length;

        // { ---------------------------- FIM CONSISTÃNCIAS ---------------------------- }
        // if(!WinPath)+'\\Teknisa\\EXP') {
        //     ForceDirectories(ExtractFileDrive(WinPath)+'\Teknisa\EXP');
        // }
        // adcSrv.StartTrans()
        // action;
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - adcSrv.StartTrans()action');
        // // {Atualiza caixa}
        // AtualizaCaixa(P_CDFILIAL, P_CDCAIXA);
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - AtualizaCaixa');
        // Atualiza consumidor
        // AbreQuery(adqSrvInsConsumidor.query);
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - abreQuery InsConsumidor');
        await this.atualizaConsumidor(
          cdsCliConsumidor,
          adqSrvInsConsumidor.query,
          adqSrvUpdConsumidor
        );
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - AtualizaConsumidor');
        // cdsCliCONSUMIDOR.EmptyDataSet;
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - cdsCliCONSUMIDOR.EmptyDataSet');
        // Edita operador
        // adqSrvInsConsumidor.query, adqSrvUpdConsumidor
        await this.editaOperador(cdsCliOperador);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - EditaOperador`,
          P_CDFILIAL
        );

        // Insere controlsenha
        await this.insereControlSenha(cdsCliControlSenha);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - InsereControlSenha`,
          P_CDFILIAL
        );

        // Insere pedidofos
        await TransfDados(
          cdsCliPedidoFos,
          true,
          cdsVendaTemp,
          cdsMovCaixaTemp,
          cdsPedidoFosTemp,
          cdsCliPedidoFos.data.length
        );
        // this.AtualizaPedidoFos(cdsCliPedidoFos, cdsCliItPedidoFos) // Quase pronta
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados PedidoFos`,
          P_CDFILIAL
        );
        // { ---------------------------- INÍCIO ATUALIZAÇÃO VENDAS ---------------------------- }
        // {Atualiza turcaixa}
        try {
          await this.AtualizaTurCaixa(
            cdsCliTurCaixa,
            stCdFilialAux,
            stCdCaixaAux
          );
        } catch (error) {
          console.log(error);
          throw error;
        }

        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - AtualizaTurCaixa`,
          P_CDFILIAL
        );
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - cdsCliTurcaixa.EmptyDataSet`,
          P_CDFILIAL
        );
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - abreQuery Venda`,
          P_CDFILIAL
        );

        // Atualiza venda
        try {
          await this.AtualizaVenda(
            cdsCliVenda,
            cdsCliItemVenda,
            cdsCliItHrComanda,
            cdsCliItVendaImpos,
            cdsCliMovCaixa,
            stCdFilialAux,
            stCdCaixaAux,
            cdsVendaTemp
          );
        } catch (error) {
          console.log(error);
          throw error;
        }

        // Insere lognfce
        await TransfDados(cdsCliLogNfce, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados LogNFCe`,
          P_CDFILIAL
        );

        try {
          await this.insertMovCaixaVenda(cdsCliMovCaixa.data);
        } catch (error) {
          console.log(error);
        }

        // Insere itvendacan
        await TransfDados(cdsCliItVendaCan, true, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ItVendaCan`,
          P_CDFILIAL
        );

        // Insere itvendades
        await TransfDados(cdsCliItVendaDes, true);
        InfoLogger.write(
          // P_CDFILIAL,
          // P_CDCAIXA,
          "setInsereServidor - TransfDados ItVendaDes",
          P_CDFILIAL
        );

        // Insere itemvendaest
        await TransfDados(cdsCliITEMVENDAEST, true, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ItemVendaEst`,
          P_CDFILIAL
        );

        // {Insere moviclie}
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - abreQuery MoviClie`,
          P_CDFILIAL
        );
        await TransfDados(
          cdsCliMoviClie,
          true,
          cdsVendaTemp,
          cdsMovCaixaTemp,
          cdsPedidoFosTemp,
          cdsCliPedidoFos.length
        );
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados MoviClie`,
          P_CDFILIAL
        );
        await this.atualizaMoviClie(P_CDFILIAL);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - AtualizaMoviClie`,
          P_CDFILIAL
        );
        cdsCliMoviClie.setData([]);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - cdsCliMoviClie.EmptyDataSet`,
          P_CDFILIAL
        );

        // Insere extratocons
        await this.atualizaExtratoCons(cdsCliExtratoCons, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - AtualizaExtratoCons`,
          P_CDFILIAL
        );

        // Insere extratoconspend
        await this.atualizaExtratoConsPend(cdsCliExtratoConsPend, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - AtualizaExtratoConsPend`,
          P_CDFILIAL
        );
        // Insere itfidelidade
        await TransfDados(cdsCliItFidelidade, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - AtualizaItfidelidade`,
          P_CDFILIAL
        );
        // Insere obsitemvenda
        await TransfDados(cdsCliObsItemVenda, true, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ObsItemVenda`,
          P_CDFILIAL
        );
        // Insere obsitemvendaest
        await TransfDados(cdsCliObsItemVendaEst, true, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ObsItemVendaEst`,
          P_CDFILIAL
        );

        // Atualiza movbeneficioctr
        this.atualizaMovBeneficioCtr(
          cdsCliMovBeneficioCtr,
          cdsCliMovBeneficioCons,
          cdsCliVenda,
          P_CDFILIAL,
          P_CDCAIXA
        );
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - abreQuery MovBeneficioCtr`,
          P_CDFILIAL
        );

        // Insere movbeneficiocons
        await TransfDados(cdsCliMovBeneficioCons, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados MovBeneficioCons`,
          P_CDFILIAL
        );

        // Insere UsoCupomDescFos
        await TransfDados(cdsCliUsoCupomDescFos, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados UsoCupomDescFos`,
          P_CDFILIAL
        );

        // Insere PromoVenda
        await TransfDados(cdsCliPromoVenda, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados PromoVenda`,
          P_CDFILIAL
        );
        // // { ---------------------------- FIM ATUALIZAÇÃO VENDAS ---------------------------- }
        // Insere itpedidofos
        await this.insereItPedidoFos(
          cdsCliItPedidoFos,
          cdsPedidoFosTemp,
          cdsVendaTemp
        );
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - InsereItPedidoFos`,
          P_CDFILIAL
        );

        // Insere kds_temp_setorest
        await TransfDados(cdsCliKdsTempSetorEst, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados KdsTempSetorEst`,
          P_CDFILIAL
        );

        // Insere logoperfos
        await TransfDados(cdsLOGOPERFOS, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados LogOperFos`,
          P_CDFILIAL
        );

        // Insere logacesso
        await TransfDados(cdsCliLOGACESSO, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados LogAcesso`,
          P_CDFILIAL
        );

        // Insere inutilizanfce
        await TransfDados(cdsCliINUTILIZANFCE, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados InutilizaNFCE`,
          P_CDFILIAL
        );

        // Insere arqcat52
        await TransfDados(cdsCliARQCAT52, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ArqCat52`,
          P_CDFILIAL
        );
        // Insere estornovnd
        await this.insereEstornoVnd(cdsCliEstornoVnd, P_CDFILIAL, P_CDCAIXA);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - InsereEstornoVnd`,
          P_CDFILIAL
        );
        // Insere itcomandapend

        await TransfDados(cdsCliITCOMANDAPEND, true, cdsVendaTemp);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ItComandaPend`,
          P_CDFILIAL
        );

        // Insere logsincdlv
        await TransfDados(cdsCliLogSincDlv, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados LogSincDlv`,
          P_CDFILIAL
        );

        // Verifica tipo do caixa
        const params = { P_CDFILIAL, P_CDCAIXA };
        const adqVerificaEmissCaixaResult = await adqVerificaEmissCaixa.get(
          params
        );
        if (
          this.getAdqFieldValue(
            adqVerificaEmissCaixaResult,
            "IDTPEMISSAOFOS"
          ) === "FNC"
        ) {
          // Insere novocodigo nfce
          const adqVerificaCDSERIECXResult = await adqVerificaCDSERIECX.get(
            params
          );

          const cdSerieCx =
            this.getAdqFieldValue(adqVerificaCDSERIECXResult, "CDSERIECX") ||
            P_CDCAIXA;

          await this.apagaNovoCodigoNFCE(
            P_CDFILIAL,
            cdSerieCx,
            cdsCliNOVOCODNFCE
          );
          InfoLogger.write(
            `${P_CDFILIAL} ${cdSerieCx} setInsereServidor - apagaNovoCodigoNFCE`,
            P_CDFILIAL
          );

          await TransfDados(cdsCliNOVOCODNFCE, true);
          InfoLogger.write(
            `${P_CDFILIAL} ${cdSerieCx} setInsereServidor - TransfDados NovoCodNFCE`,
            P_CDFILIAL
          );
        }

        // ---------------------------- INÍCIO ATUALIZAÇÃO REDUÇÃO Z ----------------------------

        // Insere redução z
        await TransfDados(cdsCliReducaoZ, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ReducaoZ`,
          P_CDFILIAL
        );

        // Insere impostoredz
        await TransfDados(cdsCliIMPOSTOREDZ, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ImpostoRedZ`,
          P_CDFILIAL
        );

        // Insere formpgtoredz
        await TransfDados(cdsCliFORMPGTOREDZ, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados FormPgtoRedz`,
          P_CDFILIAL
        );

        // Insere totnfiscredz
        await TransfDados(cdsCliTOTNFISCREDZ, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados TotNFiscRedZ`,
          P_CDFILIAL
        );

        // Insere prodbloqvndtaa
        await TransfDados(cdsCliProdBloqVndTaa, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados ProdBloqVndTaa`,
          P_CDFILIAL
        );

        // Insere endecons
        await TransfDados(cdsCliEndeCons, true);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - TransfDados EndeCons`,
          P_CDFILIAL
        );

        // // { ---------------------------- FIM ATUALIZAÇÃO REDU��O Z ---------------------------- }
        // adcSrv.Commit;
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - adcSrv.Commit');
        // if(!cdsCliReducaoZ.length == 0){
        //     VerificaBaseCalc(cdsCliReducaoZ['CDFILIAL'  ],
        //                     cdsCliReducaoZ['CDCAIXA'   ],
        //                     cdsCliReducaoZ['NRECFREDZ' ],
        //                     cdsCliReducaoZ['DTREDUCAOZ']);
        //     InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - VerificaBaseCalc');
        // }
        // // cdsCliReducaoZ.EmptyDataSet;
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - cdsCliReducaoZ.EmptyDataSet');
        await this.gravaArqCat52(cdsCliARQCAT52);
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - GravaArqCat52');
        // // cdsCliARQCAT52.EmptyDataSet;
        // InfoLogger.write(P_CDFILIAL,P_CDCAIXA,'setInsereServidor - cdsCliARQCAT52.EmptyDataSet');

        // Atualiza TotalDiaCaixa
        await this.atualizaTotalDiaCaixa(
          cdsCliTotalDiaCaixa,
          adqSrvTotalDiaCaixa.query,
          adqVerifTotalDiaCaixa
        );
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - atualizaTotalDiaCaixa`,
          P_CDFILIAL
        );
      } catch (error) {
        if (error) {
          // if(adcSrv.InTransaction) {
          //     adcSrv.RollBack;
          // }
          return error;
        }
      }
    } finally {
      await this.apagaVendasDuplicadas(cdsCliVenda);
      InfoLogger.write(
        `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - ApagaVendasDuplicadas`,
        P_CDFILIAL
      );

      await this.apagaSangriaDuplicada(cdsCliMovCaixa);
      InfoLogger.write(
        `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - ApagaSangriaDuplicada`,
        P_CDFILIAL
      );

      // Insere relvendas
      await this.atualizaRelatorioVendas(cdsCliRelVendas);
      InfoLogger.write(
        `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - AtualizaRelatorioVendas`,
        P_CDFILIAL
      );

      if (existeTurCaixa) {
        // Comentado nas versões 6.27 e 6.28
        // Recalcula o valor dos impostos utilizando a função RoundABNT
        await this.corrigeItVendaImpos(P_CDFILIAL, P_CDCAIXA);
        InfoLogger.write(
          `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - CorrigeItVendaImpos`,
          P_CDFILIAL
        );
      }

      InfoLogger.write(
        `${P_CDFILIAL} ${P_CDCAIXA} setInsereServidor - FIM`,
        P_CDFILIAL
      );
    }
  }

  async AtualizaTurCaixa(DataSetOrigem, stCdFilialAux, stCdCaixaAux) {
    const arrProm = [];
    if (DataSetOrigem.data.length) {
      for (const item of DataSetOrigem.data) {
        if (item["IDATUTURCAIXA"] === "I") {
          InfoLogger.write(
            `${stCdFilialAux} ${stCdCaixaAux} AtualizaTurcaixa > InsereTurCaixa`,
            stCdFilialAux
          );
          try {
            const result = await this.InsereTurCaixa(
              item,
              DataSetOrigem.tabela,
              stCdFilialAux,
              stCdCaixaAux
            );
            arrProm.push(result);
          } catch (error) {}
        } else {
          InfoLogger.write(
            `${stCdFilialAux} ${stCdCaixaAux} - AtualizaTurcaixa > EditaTurCaixa`,
            stCdFilialAux
          );
          try {
            const result = await this.InsereTurCaixa(
              item,
              DataSetOrigem.tabela,
              stCdFilialAux,
              stCdCaixaAux
            );
            arrProm.push(result);
          } catch (error) {}
        }
      }
    }
    return await Promise.all(arrProm).then((result) => {
      return result;
    });
  }

  async getMinDtUltAtuExt(minDtUltAtu) {
    const params = [];
    params["P_DTULTATUEXT"] = minDtUltAtu;
    try {
      const result = await adqMinDtUltAtuExtModel.get(params);
      return result.length ? result : new Date();
    } catch (error) {
      return error;
    }
  }

  async getMaxDtUltAtuMCli(maxDtUltAtuMCli) {
    const params = [];
    params["P_DTULTATUMCLI"] = maxDtUltAtuMCli;
    try {
      const result = await adqMaxDtuUltAtuMCLIModel.get(params);
      return result.length ? result : new Date();
    } catch (error) {
      return error;
    }
  }

  async InsereTurCaixa(DataSetOrigem, tabela) {
    try {
      let params = [];
      params["P_CDFILIAL"] = DataSetOrigem["CDFILIAL"];
      params["P_CDCAIXA"] = DataSetOrigem["CDCAIXA"];
      params["P_DTABERCAIX"] = DateFormat(DataSetOrigem["DTABERCAIX"]);
      const { insertQuery, updateQuery, fields } = await ConstructQuery(
        "TURCAIXA",
        ["CDFILIAL", "CDCAIXA", "DTABERCAIX"]
      );
      let adqVerifTurCaixa_result;
      try {
        adqVerifTurCaixa_result = await adqVerifTurCaixa.get(params);
      } catch (error) {}

      const missedFields = [];
      const item = DataSetOrigem;
      const mapKeys = Object.keys(item);
      let printSql = false;
      try {
        params = [];

        for (const field of fields) {
          if (mapKeys.indexOf(field.name) >= 0) {
            if (field.name == "DTABERCAIX") {
              printSql = true;
            }
            if (field.dbTypeName == "DATE") {
              params[field.name] = DateFormat(item[field.name]);
            } else {
              params[field.name] = item[field.name];
            }
          } else {
            missedFields.push(field.name);
          }
        }

        if (missedFields.length) {
          throw {
            error: "true",
            message: `missing fields on ${tabela}`,
            fields: missedFields,
          };
        } else {
          // Execute insertion or edit here
          if (adqVerifTurCaixa_result.rows.length) {
            // edit
            try {
              params["IDATUTURCAIXA"] = "S";
              params["DTEXPTURCAIXA"] = DateFormat(new Date() - 3);
              try {
                const execution = await OracleService.execute(
                  updateQuery,
                  params
                );
                execution.connection.commit();
                return true;
              } catch (error) {
                return error;
              }
            } catch (error) {
              return error;
            }
          } else {
            // insert
            try {
              params["IDATUTURCAIXA"] = "S";
              try {
                if (printSql) {
                }
                const execution = await OracleService.execute(
                  insertQuery,
                  params
                );
                execution.connection.commit();
                return true;
              } catch (error) {
                return error;
              }
            } catch (error) {
              return error;
            }
          }
        }
      } catch (error) {
        throw error;
      }
    } catch (error) {
      if (error) {
        throw error;
      }
    }
  }

  async getVerificaExportacao(P_OLERESULT) {
    try {
      try {
        const oleRetTabelas = [];

        this.cdsCliCONSUMIDOR = new ClientDataSet(P_OLERESULT[0]["DATA"]);
        this.cdsCliOperador = new ClientDataSet(P_OLERESULT[1]["DATA"]);
        this.cdsLOGOPERFOS = new ClientDataSet(P_OLERESULT[2]["DATA"]);
        this.cdsCliLOGACESSO = new ClientDataSet(P_OLERESULT[3]["DATA"]);
        this.cdsCliControlSenha = new ClientDataSet(P_OLERESULT[4]["DATA"]);
        this.cdsCliINUTILIZANFCE = new ClientDataSet(P_OLERESULT[5]["DATA"]);
        this.cdsCliITCOMANDAPEND = new ClientDataSet(P_OLERESULT[6]["DATA"]);
        this.cdsCliPedidoFos = new ClientDataSet(P_OLERESULT[7]["DATA"]);
        this.cdsCliItPedidoFos = new ClientDataSet(P_OLERESULT[8]["DATA"]);
        // this.cdsCliNOVOCODNFCE      = P_OLERESULT[9];
        this.cdsCliArqCat52 = new ClientDataSet(P_OLERESULT[10]["DATA"]);
        this.cdsCliReducaoZ = new ClientDataSet(P_OLERESULT[11]["DATA"]);
        this.cdsCliIMPOSTOREDZ = new ClientDataSet(P_OLERESULT[12]["DATA"]);
        this.cdsCliTOTNFISCREDZ = new ClientDataSet(P_OLERESULT[13]["DATA"]);
        this.cdsCliFORMPGTOREDZ = new ClientDataSet(P_OLERESULT[14]["DATA"]);
        this.cdsCliTurCaixa = new ClientDataSet(P_OLERESULT[15]["DATA"]);
        this.cdsCliVenda = new ClientDataSet(P_OLERESULT[16]["DATA"]);
        this.cdsCliExtratoCons = new ClientDataSet(P_OLERESULT[17]["DATA"]);
        this.cdsCliItemVenda = new ClientDataSet(P_OLERESULT[18]["DATA"]);
        this.cdsCliItVendaImpos = new ClientDataSet(P_OLERESULT[19]["DATA"]);
        this.cdsCliItVendaCan = new ClientDataSet(P_OLERESULT[20]["DATA"]);
        this.cdsCliITEMVENDAEST = new ClientDataSet(P_OLERESULT[21]["DATA"]);
        this.cdsCliMovCaixa = new ClientDataSet(P_OLERESULT[22]["DATA"]);
        this.cdsCliMoviClie = new ClientDataSet(P_OLERESULT[23]["DATA"]);
        this.cdsCliEstornoVnd = new ClientDataSet(P_OLERESULT[24]["DATA"]);
        this.cdsCliItFidelidade = new ClientDataSet(P_OLERESULT[25]["DATA"]);
        this.cdsCliMovBeneficioCons = new ClientDataSet(
          P_OLERESULT[26]["DATA"]
        );
        this.cdsCliMovBeneficioCtr = new ClientDataSet(P_OLERESULT[27]["DATA"]);
        this.cdsCliObsItemVenda = new ClientDataSet(P_OLERESULT[28]["DATA"]);
        this.cdsCliObsItemVendaEst = new ClientDataSet(P_OLERESULT[29]["DATA"]);
        this.cdsCliItHrComanda = new ClientDataSet(P_OLERESULT[30]["DATA"]);
        this.cdsCliRelVendas = new ClientDataSet(P_OLERESULT[31]["DATA"]);
        this.cdsCliItVendaDes = new ClientDataSet(P_OLERESULT[32]["DATA"]);
        this.cdsCliExtratoConsPend = new ClientDataSet(P_OLERESULT[33]["DATA"]);
        this.cdsCliUsoCupomDescFos = new ClientDataSet(P_OLERESULT[34]["DATA"]);
        this.cdsCliLogSincDlv = new ClientDataSet(P_OLERESULT[35]["DATA"]);
        this.cdsCliTotalDiaCaixa = new ClientDataSet(P_OLERESULT[36]["DATA"]);
        this.cdsCliProdBloqVndTaa = new ClientDataSet(P_OLERESULT[37]["DATA"]);
        this.cdsCliEndeCons = new ClientDataSet(P_OLERESULT[38]["DATA"]);
        this.cdsCliLogNfce = new ClientDataSet(P_OLERESULT[39]["DATA"]);
        this.cdsCliKdsTempSetorEst = new ClientDataSet(P_OLERESULT[40]["DATA"]);
        this.cdsCliPromoVenda = new ClientDataSet(P_OLERESULT[41]["DATA"]);

        const cdsRetConsumidor = await this.verificaConsumidor(
          this.cdsCliCONSUMIDOR
        );
        const cdsRetOperador = await this.verificaOperador(this.cdsCliOperador);
        const cdsRetControlSenha = await this.verificaControlSenha(
          this.cdsCliControlSenha
        );
        const cdsRetInutilizaNfce = await this.verificaInutilizaNfce(
          this.cdsCliINUTILIZANFCE
        );
        await this.VerificaPedidoFos();
        const cdsRetArqCat52 = await this.verificaArqCat52(this.cdsCliArqCat52);
        await this.VerificaTurCaixa();
        await this.VerificaVenda();
        await this.VerificaMovCaixa();
        await this.verificaLogOperFos();
        await this.VerificaLogAcesso();
        const cdsRetExtratoCons = await this.verificaExtratoCons(
          this.cdsCliExtratoCons
        );
        const cdsRetExtratoConsPend = await this.verificaExtratoCons(
          this.cdsCliExtratoConsPend
        );
        if (cdsRetExtratoConsPend.data.length) {
          cdsRetExtratoCons.data = cdsRetExtratoCons.data.concat(
            cdsRetExtratoConsPend.data
          );
        }

        const cdsRetReducaoz = await this.verificaReducaoZ(this.cdsCliReducaoZ);
        const cdsRetEstornoVnd = await this.verificaEstornoVnd(
          this.cdsCliEstornoVnd
        );
        const cdsRetMovBeneCtr = await this.verificaMovBeneCtr(
          this.cdsCliMovBeneficioCtr
        );
        const cdsRetCliLogSincDlv = await this.verificaLogSincDlv(
          this.cdsCliLogSincDlv
        );
        // //VerificaItHrComanda; // Já estava comentada
        const cdsRetTotalDiaCaixa = await this.verificaTotalDiaCaixa(
          this.cdsCliTotalDiaCaixa
        );

        const cdsRetProdBloqVndTaa = await this.VerificaProdBloqVndTaa(
          this.cdsCliProdBloqVndTaa
        );

        const cdsRetEndeCons = await this.VerificaEndeCons(this.cdsCliEndeCons);

        const cdsRetLogNfce = await this.VerificaLogNfce(this.cdsCliLogNfce);

        oleRetTabelas[0] = {
          DATA: cdsRetConsumidor.data,
          TABLENAME: "CONSUMIDOR",
        };

        oleRetTabelas[1] = {
          DATA: cdsRetOperador.data,
          TABLENAME: "OPERADOR",
        };

        oleRetTabelas[2] = {
          DATA: cdsRetLogOperFos.data,
          TABLENAME: "LOGOPERFOS",
        };
        oleRetTabelas[3] = {
          DATA: cdsRetLogAcesso.data,
          TABLENAME: "LOGACESSO",
        };
        oleRetTabelas[4] = {
          DATA: cdsRetControlSenha.data,
          TABLENAME: "CONTROLSENHA",
        };
        oleRetTabelas[5] = {
          DATA: cdsRetInutilizaNfce.data,
          TABLENAME: "INUTILIZANFCE",
        };
        oleRetTabelas[6] = {
          DATA: cdsRetPedidoFos.data,
          TABLENAME: "PEDIDOFOS",
        };
        oleRetTabelas[7] = {
          DATA: cdsRetArqCat52.data,
          TABLENAME: "ARQCAT52",
        };
        oleRetTabelas[8] = {
          DATA: cdsRetReducaoz.data,
          TABLENAME: "REDUCAOZ",
        };
        oleRetTabelas[9] = {
          DATA: cdsRetTurCaixa.data,
          TABLENAME: "TURCAIXA",
        };
        oleRetTabelas[10] = {
          DATA: cdsRetVenda.data,
          TABLENAME: "VENDA",
        };
        oleRetTabelas[11] = {
          DATA: cdsRetMovCaixa.data,
          TABLENAME: "MOVCAIXA",
        };
        cdsRetTurCaixa.data = [];
        cdsRetVenda.data = [];
        cdsRetPedidoFos.data = [];
        cdsRetMovCaixa.data = [];
        cdsRetLogOperFos.data = [];
        cdsRetLogAcesso.data = [];

        oleRetTabelas[12] = {
          DATA: cdsRetExtratoCons.data,
          TABLENAME: "EXTRATOCONS",
        };
        oleRetTabelas[13] = {
          DATA: cdsRetEstornoVnd.data,
          TABLENAME: "ESTORNOVND",
        };
        oleRetTabelas[14] = {
          DATA: cdsRetMovBeneCtr.data,
          TABLENAME: "MOVBENEFICIOCTR",
        };
        oleRetTabelas[15] = {
          DATA: cdsRetCliLogSincDlv.data,
          TABLENAME: "MOVCAIXA",
        };
        oleRetTabelas[16] = {
          DATA: cdsRetTotalDiaCaixa.data,
          TABLENAME: "TOTALDIACAIXA",
        };

        oleRetTabelas[17] = {
          DATA: cdsRetProdBloqVndTaa.Data,
          TABLENAME: "PRODBLOQVNDTAA",
        };

        oleRetTabelas[18] = {
          DATA: cdsRetEndeCons.Data,
          TABLENAME: "ENDECONS",
        };

        oleRetTabelas[19] = {
          DATA: cdsRetLogNfce.Data,
          TABLENAME: "LOGNFCE",
        };

        return oleRetTabelas;
      } catch (error) {
        if (error) {
          return error;
        }
      }
    } finally {
      // return oleRetTabelas
    }
  }

  ConsisteTurCaixa() {
    //    this.cdsCliTurCaixa.Filtered = False;
    //    cdsCliTurCaixa.Filter   = 'IDATUTURCAIXA == '+'\''+'I'+'\'';
    //    cdsCliTurCaixa.Filtered = True;
    //    cdsCliTurCaixa.First();
    //    while (!cdsCliTurCaixa.Eof) do {
    //       with(adqVerifTurCaixa) do {
    //          Close();
    //          params['P_CDFILIAL'  ]   = cdsCliTurCaixa['CDFILIAL'  ];
    //          params['P_CDCAIXA'   ]   = cdsCliTurCaixa['CDCAIXA'   ];
    //          params['P_DTABERCAIX'] = cdsCliTurCaixa['DTABERCAIX'];
    //          Open();
    //       }
    //       if(!adqVerifTurCaixa.length == 0){
    //          if((adqVerifTurCaixa['DTFECHCAIX'] != cdsCliTurCaixa['DTFECHCAIX']) or
    //             (adqVerifTurCaixa['CDOPERFECH'] != cdsCliTurCaixa['CDOPERFECH']) or
    //             (adqVerifTurCaixa['IDULTFECHAMEN'] != cdsCliTurCaixa['IDULTFECHAMEN']) {
    //             cdsCliTurCaixa.Next();
    //          } else {
    //             cdsCliTurCaixa.Delete;
    //          }
    //       } else {
    //          cdsCliTurCaixa.Next();
    //       }
    //    }
    //    cdsCliTurCaixa.Filtered = False;
    //    cdsCliTurCaixa.First();
  }

  async VerificaTurCaixa() {
    let stIdSituacao = "NOK";

    try {
      for (const turcaixa of this.cdsCliTurCaixa.data) {
        const params = [];
        params["P_CDFILIAL"] = turcaixa["CDFILIAL"];
        params["P_CDCAIXA"] = turcaixa["CDCAIXA"];
        params["P_DTABERCAIX"] = DateFormat(turcaixa["DTABERCAIX"]);
        const adqVerifTurCaixaResult = await adqVerifTurCaixa.get(params);
        const fields = adqVerifTurCaixaResult.metaData;
        adqVerifTurCaixaResult.row = {};

        fields.forEach((it, idx) => {
          if (adqVerifTurCaixaResult.rows[0]) {
            adqVerifTurCaixaResult.row[it.name] =
              adqVerifTurCaixaResult.rows[0][idx];
          }
        });

        turcaixa["DTFECHCAIX"] = DateFormat(turcaixa["DTFECHCAIX"]);
        adqVerifTurCaixaResult.row["DTFECHCAIX"] = adqVerifTurCaixaResult.row[
          "DTFECHCAIX"
        ]
          ? DateFormat(adqVerifTurCaixaResult.row["DTFECHCAIX"])
          : null;

        if (turcaixa["IDATUTURCAIXA"] === "I") {
          // Inclusão
          stIdSituacao = adqVerifTurCaixaResult.row === {} ? "NOK" : "OK";
        } else {
          // Alteração
          stIdSituacao =
            turcaixa["DTFECHCAIX"] === adqVerifTurCaixaResult.row["DTFECHCAIX"]
              ? "OK"
              : "NOK";
        }

        const turcaixaResult = {
          CDFILIAL: turcaixa["CDFILIAL"],
          CDCAIXA: turcaixa["CDCAIXA"],
          DTABERCAIX: DateFormat(turcaixa["DTABERCAIX"]),
          DTEXPTURCAIXA: DateFormat(
            adqVerifTurCaixaResult.row["DTEXPTURCAIXA"]
          ),
          IDSITUACAO: stIdSituacao,
          DTFECHCAIX: adqVerifTurCaixaResult.row["DTFECHCAIX"],
        };

        cdsRetTurCaixa.data.push(turcaixaResult);
      }
    } catch (error) {}
  }

  async VerificaVenda() {
    try {
      let stIdSituacao = "NOK";

      for (const venda of this.cdsCliVenda.data) {
        const params = [];
        params["P_CDFILIAL"] = venda["CDFILIAL"];
        params["P_CDCAIXA"] = venda["CDCAIXA"];
        params["P_DTABERTUR"] = DateFormat(venda["DTABERTUR"]);
        params["P_NRSEQVENDA"] = venda["NRSEQVENDAMSDE"];
        try {
          const adqVerifVendaResult = await adqVerifVenda.execute(params);

          const fields = adqVerifVendaResult.metaData;

          adqVerifVendaResult.row = {};

          fields.forEach((it, idx) => {
            if (adqVerifVendaResult.rows[0]) {
              adqVerifVendaResult.row[it.name] =
                adqVerifVendaResult.rows[0][idx];
            }
          });

          // Start with this
          if (venda["IDIMPVENDA"] === "I") {
            // Inclusão
            stIdSituacao = adqVerifVendaResult.row === {} ? "NOK" : "OK";
          } else {
            // Alteração
            stIdSituacao =
              venda["IDSITUVENDA"] === adqVerifVendaResult.row["IDSITUVENDA"]
                ? "OK"
                : "NOK";
          }

          const vendaResult = {
            CDFILIAL: venda["CDFILIAL"],
            CDCAIXA: venda["CDCAIXA"],
            NRSEQVENDA: venda["NRSEQVENDA"],
            IDSITUACAO: stIdSituacao,
            IDSITUVENDA: adqVerifVendaResult.row["IDSITUVENDA"],
            CDVENDEDOR: adqVerifVendaResult.row["CDVENDEDOR"],
            IDENVIOFID4ALL: adqVerifVendaResult.row["IDENVIOFID4ALL"],
            IDENVIOFIDUDS: adqVerifVendaResult.row["IDENVIOFIDUDS"],
          };

          cdsRetVenda.data.push(vendaResult);
        } catch (error) {
          console.log(error);
        }
      }

      return cdsRetVenda;
    } catch (error) {}
  }

  async VerificaMovCaixa() {
    if (!this.cdsCliMovCaixa.data) {
      return;
    }
    for (const movCaixa of this.cdsCliMovCaixa.data) {
      const params = [];
      params["P_CDFILIAL"] = movCaixa["CDFILIAL"];
      params["P_CDCAIXA"] = movCaixa["CDCAIXA"];
      params["P_DTABERCAIX"] = DateFormat(movCaixa["DTABERCAIX"]);
      params["P_NRSEQUMOVI"] = movCaixa["NRSEQUMOVIMSDE"];

      let adqVerifMovCaixaResult = {};
      try {
        adqVerifMovCaixaResult = await adqVerifMovCaixa.get(params);
      } catch (error) {}
      const stIdSituacao = !adqVerifMovCaixaResult.rows.length ? "NOK" : "OK";

      adqVerifMovCaixaResult.row = adqVerifMovCaixaResult.rows[0];

      if (!adqVerifMovCaixaResult.rows.length) {
        if (movCaixa["NRSEQVENDA"] !== "") {
          if (adqVerifMovCaixa["NRSEQVENDA"] === "") {
            const params = [];
            params["P_CDFILIAL"] = movCaixa["CDFILIAL"];
            params["P_CDCAIXA"] = movCaixa["CDCAIXA"];
            params["P_DTABERTUR"] = movCaixa["DTABERCAIX"];
            params["P_NRSEQVENDA"] = movCaixa["NRSEQVENDA"];

            const adqVerifVendaResult = await adqVerifVenda.get(params);
            adqVerifVendaResult.row = adqVerifVendaResult.rows[0];
            if (adqVerifVendaResult.rows.length) {
              params["CDFILIAL"] = adqVerifVendaResult.row["CDFILIAL"];
              params["CDCAIXA"] = adqVerifVendaResult.row["CDCAIXA"];
              params["DTABERCAIX"] = adqVerifVendaResult.row["DTABERCAIX"];
              params["NRSEQUMOVI"] = adqVerifVendaResult.row["NRSEQUMOVI"];
              params["NRSEQVENDA"] = adqVerifVendaResult.row["NRSEQVENDA"];
              acmUpdNrSeqVenda.execute(params);
            }
          }
        }
      }
      const retMovCaixa = {};
      retMovCaixa["CDFILIAL"] = movCaixa["CDFILIAL"];
      retMovCaixa["CDCAIXA"] = movCaixa["CDCAIXA"];
      retMovCaixa["DTABERCAIX"] = DateFormat(movCaixa["DTABERCAIX"]);
      retMovCaixa["NRSEQUMOVI"] = movCaixa["NRSEQUMOVI"];
      retMovCaixa["IDSITUACAO"] = stIdSituacao;

      cdsRetMovCaixa.data.push(retMovCaixa);
    }
  }

  LimpaQrCode(DataSetOrigem) {
    //    Try
    //       //Verifica se existe registro na vendarest
    //       with(adqVerifVendarest, Params) do {
    //          Close();
    //          params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //          //Para pedidos Qrcode o nrvendaresst do oracle � igual ao do MSDE
    //          params['P_NRVENDAREST' ] = DataSetOrigem['NRVENDAREST'];
    //          params['P_NRCOMANDA'   ] = DataSetOrigem['NRCOMANDAVND'];
    //          params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //          params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //          Open();
    //       }
    //       if(!adqVerifVendarest.IsEmpty) {
    //          with(acmUpdVendarest) do {
    //            params['P_CDFILIAL'    ] = adqVerifVendarest['CDFILIAL'];
    //            params['P_CDLOJA'      ] = adqVerifVendarest['CDLOJA'];
    //            params['P_NRVENDAREST' ] = adqVerifVendarest['NRVENDAREST'];
    //            params['P_CDCLIENTE'   ] = adqVerifVendarest['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = adqVerifVendarest['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          {with(acmDelItComandaven) do {      //Limpar tabela itcomandaven
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST' ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_NRCOMANDA'   ] = DataSetOrigem['NRCOMANDAVND'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          with(acmDelComandaven) do {        //Limpar tabela comandaven
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST'   ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_NRCOMANDA'   ] = DataSetOrigem['NRCOMANDAVND'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          with(acmDelMovCaixaDlv) do {       //Limpar tabela movcaixadlv
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST'   ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          with(acmDelVendarest) do {         //Limpar tabela vendarest
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST'   ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }}
    //       }
    //    } catch(error) {
    //    }
  }

  ConsisteVenda() {
    //    cdsCliVenda.Filtered = False;
    //    cdsCliVenda.Filter   = 'IDIMPVENDA == '+'\''+'I'+'\'';
    //    cdsCliVenda.Filtered = True;
    //    cdsCliVenda.First();
    //    while (!cdsCliVenda.Eof) do {
    //       with(adqVerifTurCaixa) do { // Verifica se a abertura da venda j� foi inclu�da no servidor
    //          Close();
    //          params['P_CDFILIAL'  ]   = cdsCliVenda['CDFILIAL' ];
    //          params['P_CDCAIXA'   ]   = cdsCliVenda['CDCAIXA'  ];
    //          params['P_DTABERCAIX'] = cdsCliVenda['DTABERTUR'];
    //          Open();
    //       }
    //       dtAberTur = cdsCliVenda['DTABERTUR'];
    //       if(!adqVerifTurCaixa.length == 0){ // Se a abertura j� existe no servidor
    //          // Cada abertura � verificada somente uma vez
    //          while ((!cdsCliVenda.Eof) and (dtAberTur == cdsCliVenda['DTABERTUR'])) do {
    //             with(adqVerifVenda) do {
    //                Close();
    //                params['P_CDFILIAL'  ]   = cdsCliVenda['CDFILIAL'      ];
    //                params['P_CDCAIXA'   ]   = cdsCliVenda['CDCAIXA'       ];
    //                params['P_DTABERTUR' ] = cdsCliVenda['DTABERTUR'     ];
    //                params['P_NRSEQVENDA']   = cdsCliVenda['NRSEQVENDAMSDE'];
    //                Open();
    //             }
    //             if(!adqVerifVenda.length == 0){ // Se a venda j� existe no servidor
    //                ApagaVendaCds;
    //             } else {
    //                if(cdsCliVenda['IDSITUVENDA'] == 'O') {
    //                   cdsCliItemVenda.Filtered = False;
    //                   cdsCliItemVenda.Filter   = 'CDFILIAL   == '+'\''+cdsCliVenda['CDFILIAL'  ]+'\''+' AND '+
    //                                               'CDCAIXA    == '+'\''+cdsCliVenda['CDCAIXA'   ]+'\''+' AND '+
    //                                               'NRSEQVENDA == '+'\''+cdsCliVenda['NRSEQVENDA']+'\'';
    //                   cdsCliItemVenda.Filtered = True;
    //                   if(cdsCliItemVenda.length == 0){
    //                      ApagaVendaCds;
    //                   } else {
    //                      cdsCliVenda.Next();
    //                   }
    //                   cdsCliItemVenda.Filtered = False;
    //                } else {
    //                   cdsCliVenda.Next();
    //                }
    //             }
    //          }
    //       } else { // Se a abertura n�o existe no servidor
    //          if(!'CDFILIAL' ],
    //                                                                                  cdsCliVenda['CDCAIXA'  ],
    //                                                                                  cdsCliVenda['DTABERTUR']]), [loCaseInsensitive]) {
    //             ApagaVendaCds;
    //          } else {
    //             // Cada abertura � verificada somente uma vez
    //             while ((!cdsCliVenda.Eof) and (dtAberTur == cdsCliVenda['DTABERTUR'])) do {
    //                with(adqVerifVenda) do {
    //                   Close();
    //                   params['P_CDFILIAL'  ]   = cdsCliVenda['CDFILIAL'      ];
    //                   params['P_CDCAIXA'   ]   = cdsCliVenda['CDCAIXA'       ];
    //                   params['P_DTABERTUR' ] = cdsCliVenda['DTABERTUR'     ];
    //                   params['P_NRSEQVENDA']   = cdsCliVenda['NRSEQVENDAMSDE'];
    //                   Open();
    //                }
    //                if(!adqVerifVenda.length == 0){ // Se a venda j� existe no servidor
    //                   ApagaVendaCds;
    //                } else {
    //                   cdsCliVenda.Next();
    //                }
    //             }
    //          }
    //       }
    //    }
    //    // Consiste vendas SAT e NFC-e
    //    cdsCliVenda.Filtered = False;
    //    cdsCliVenda.Filter   = 'IDTPEMISVEND == ''S'' OR IDTPEMISVEND == ''N''';
    //    cdsCliVenda.Filtered = True;
    //    cdsCliVenda.First();
    //    while ((!cdsCliVenda.Eof)) do {
    //       if((cdsCliVenda['IDVENDAGERENCIAL'] != 'S') and (cdsCliVenda['IDSITUVENDA'] != 'D') {
    //          if(EmptyString(cdsCliVenda['NRACESSONFCE']) and (cdsCliVenda['IDSTATUSNFCE'] != 'R') {
    //             ApagaVendaCds;
    //          } else if((cdsCliVenda['IDSITUVENDA'] == 'O') and EmptyString(cdsCliVenda['NRACESSONFCE']) {
    //             ApagaVendaCds;
    //          } else {
    //             cdsCliVenda.Next();
    //          }
    //       } else {
    //          cdsCliVenda.Next();
    //       }
    //    }
    //    cdsCliVenda.Filtered            = False;
    //    cdsCliItemVenda.Filtered        = False;
    //    cdsCliItVendaImpos.Filtered     = False;
    //    cdsCliItVendaCan.Filtered       = False;
    //    cdsCliItVendaDes.Filtered       = False;
    //    cdsCliItemVendaEst.Filtered     = False;
    //    cdsCliItFidelidade.Filtered     = False;
    //    cdsCliMovCaixa.Filtered         = False;
    //    cdsCliMoviClie.Filtered         = False;
    //    cdsCliExtratoCons.Filtered      = False;
    //    cdsCliEstornoVnd.Filtered       = False;
    //    cdsCliMovBeneficioCons.Filtered = False;
    //    cdsCliObsItemVenda.Filtered     = False;
    //    cdsCliObsItemVendaEst.Filtered  = False;
    //    cdsCliItHrComanda.Filtered      = False;
    //    cdsCliPromoVenda.Filtered       = False;
    //    cdsCliVenda.First();
  }

  ConsisteMovCaixa() {
    //    cdsCliMovCaixa.First();
    //    while (!cdsCliMovCaixa.Eof) do {
    //       with(adqVerifTurCaixa) do { // Verifica se a abertura da movcaixa j� foi inclu�da no servidor
    //          Close();
    //          params['P_CDFILIAL'  ]   = cdsCliMovCaixa['CDFILIAL'  ];
    //          params['P_CDCAIXA'   ]   = cdsCliMovCaixa['CDCAIXA'   ];
    //          params['P_DTABERCAIX'] = cdsCliMovCaixa['DTABERCAIX'];
    //          Open();
    //       }
    //       dtAberCaix = cdsCliMovCaixa['DTABERCAIX'];
    //       if(!adqVerifTurCaixa.length == 0){ // Se a abertura j� existe no servidor
    //          // Cada abertura � verificada somente uma vez
    //          while ((!cdsCliMovCaixa.Eof) and (dtAberCaix == cdsCliMovCaixa['DTABERCAIX'])) do {
    //             with(adqVerifMovCaixa) do {
    //                Close();
    //                params['P_CDFILIAL'  ]   = cdsCliMovCaixa['CDFILIAL'      ];
    //                params['P_CDCAIXA'   ]   = cdsCliMovCaixa['CDCAIXA'       ];
    //                params['P_DTABERCAIX'] = cdsCliMovCaixa['DTABERCAIX'    ];
    //                params['P_NRSEQUMOVI']   = cdsCliMovCaixa['NRSEQUMOVIMSDE'];
    //                Open();
    //             }
    //             if(!adqVerifMovCaixa.length == 0){ // Se a movcaixa j� existe no servidor
    //                if(cdsCliMovCaixa['IDALTERTIPORECE').asString == 'S' ){
    //                   AlteraMovCaixa(cdsCliMovCaixa['CDFILIAL'  ],
    //                                  cdsCliMovCaixa['CDCAIXA'   ],
    //                                  cdsCliMovCaixa['NRSEQUMOVI'],
    //                                  cdsCliMovCaixa['CDTIPORECE'],
    //                                  cdsCliMovCaixa['DTABERCAIX']);
    //                cdsCliMovCaixa.Delete;
    //             } else {
    //                cdsCliMovCaixa.Next();
    //             }
    //          }
    //       } else { // Se a abertura n�o existe no servidor
    //          if(!'CDFILIAL'  ],
    //                                                                                  cdsCliMovCaixa['CDCAIXA'   ],
    //                                                                                  cdsCliMovCaixa['DTABERCAIX']]), [loCaseInsensitive]) {
    //             cdsCliMovCaixa.Delete;
    //          } else {
    //             // Cada abertura � verificada somente uma vez
    //             while ((!cdsCliMovCaixa.Eof) and (dtAberCaix == cdsCliMovCaixa['DTABERCAIX'])) do {
    //                with(adqVerifMovCaixa) do {
    //                   Close();
    //                   params['P_CDFILIAL'  ]   = cdsCliMovCaixa['CDFILIAL'      ];
    //                   params['P_CDCAIXA'   ]   = cdsCliMovCaixa['CDCAIXA'       ];
    //                   params['P_DTABERCAIX'] = cdsCliMovCaixa['DTABERCAIX'    ];
    //                   params['P_NRSEQUMOVI']   = cdsCliMovCaixa['NRSEQUMOVIMSDE'];
    //                   Open();
    //                }
    //                if(!adqVerifMovCaixa.length == 0){ // Se a movcaixa j� existe no servidor
    //                   cdsCliMovCaixa.Delete;
    //                } else {
    //                   cdsCliMovCaixa.Next();
    //                }
    //             }
    //          }
    //       }
    //    }
    //    cdsCliMovCaixa.Filtered = False;
    //    cdsCliMovCaixa.Filter   = 'NRSEQVENDA != '+ '\''+''+'\'';
    //    cdsCliMovCaixa.Filtered = True;
    //    cdsCliMovCaixa.First();
    //    while ((!cdsCliMovCaixa.Eof)) do {
    //       if(!'CDFILIAL'  ],
    //                                                                            cdsCliMovCaixa['CDCAIXA'   ],
    //                                                                            cdsCliMovCaixa['NRSEQVENDA']]), [loCaseInsensitive]) {
    //          cdsCliMovCaixa.Delete;
    //       } else {
    //          cdsCliMovCaixa.Next();
    //       }
    //    }
    //    cdsCliMovCaixa.Filter   = '';
    //    cdsCliMovCaixa.Filtered = False;
    //    cdsCliMovCaixa.First();
  }

  ConsisteItHrComanda() {
    //    cdsCliItHrComanda.First();
    //    while ((!cdsCliItHrComanda.Eof)) do {
    //       if(!'CDFILIAL'  ],
    //                                                                            cdsCliItHrComanda['CDCAIXA'   ],
    //                                                                            cdsCliItHrComanda['NRSEQVENDA']]), [loCaseInsensitive]) {
    //          cdsCliItHrComanda.Delete;
    //       } else {
    //          cdsCliItHrComanda.Next();
    //       }
    //    }
    //    cdsCliItHrComanda.First();
  }

  async getNextNrSeqVenda(filial, caixa) {
    const params = {};
    params["P_CDFILIAL"] = filial;
    params["P_CDCAIXA"] = caixa;
    let maxNrSeqVenda = await qryGetNextNrSeqVendaModel.get(params);
    maxNrSeqVenda = maxNrSeqVenda.rows[0][0];
    maxNrSeqVenda = parseInt(maxNrSeqVenda, 10) + 1;
    maxNrSeqVenda = maxNrSeqVenda.toString().padStart(10, "0");

    return maxNrSeqVenda;
  }

  async AtualizaVenda(
    vendas,
    ItemsVenda,
    itHrComanda,
    itVendaImpos,
    MovCaixa,
    stCdFilialAux,
    stCdCaixaAux,
    cdsVendaTemp
  ) {
    if (vendas) {
      let itemsThisVenda;
      let itHrComandaVenda;
      let itVendaImposVenda;
      try {
        for (const venda of vendas.data) {
          if (venda["IDIMPVENDA"] === "I") {
            InfoLogger.write(
              `${stCdFilialAux} - ${stCdCaixaAux} - AtualizaVenda > InsereVenda`,
              stCdFilialAux
            );
            try {
              itemsThisVenda = ItemsVenda.data.filter(
                (it) =>
                  it.CDFILIAL === venda.CDFILIAL &&
                  it.CDCAIXA === venda.CDCAIXA &&
                  it.NRSEQVENDA === venda.NRSEQVENDA
              );
              itHrComandaVenda = itHrComanda.data.filter(
                (it) =>
                  it.CDFILIAL === venda.CDFILIAL &&
                  it.CDCAIXA === venda.CDCAIXA &&
                  it.NRSEQVENDA === venda.NRSEQVENDA
              );
              itVendaImposVenda = itVendaImpos.data.filter(
                (it) =>
                  it.CDFILIAL === venda.CDFILIAL &&
                  it.CDCAIXA === venda.CDCAIXA &&
                  it.NRSEQVENDA === venda.NRSEQVENDA
              );
              // MovCaixaVenda = MovCaixa.data.filter(
              //     it => it.CDFILIAL == venda.CDFILIAL && it.CDCAIXA == venda.CDCAIXA && it.NRSEQVENDA == venda.NRSEQVENDA
              // )
            } catch (error) {}

            const newNrSeqVenda = await GeraNovoCodigo.prxVenda(
              venda["CDFILIAL"],
              venda["CDCAIXA"]
            );
            cdsVendaTemp.data.push({
              NRSEQANT: venda["NRSEQVENDA"],
              NRSEQNEW: newNrSeqVenda,
            });
            venda["NRSEQVENDA"] = newNrSeqVenda;

            await this.InsereVenda(
              venda,
              itemsThisVenda,
              itHrComandaVenda,
              itVendaImposVenda,
              null
            );
            InfoLogger.write(
              `${stCdFilialAux} - ${stCdCaixaAux} - AtualizaVenda > Limpar QRCode`,
              stCdFilialAux
            );
            this.LimpaQrCode(venda);
          } else {
            InfoLogger.write(
              `${stCdFilialAux} - ${stCdCaixaAux} - AtualizaVenda > Edita Venda`,
              stCdFilialAux
            );
            await this.EditaVenda(venda, cdsVendaTemp);
          }
        }
      } catch (error) {
        console.log(error);
      }
    }
  }

  async InsereVenda(venda, itemsVenda, itemsHrComanda, itVendaImpos) {
    try {
      const params = [];
      const { insertQuery, updateQuery, fields } = await ConstructQuery(
        "VENDA",
        ["CDFILIAL", "CDCAIXA", "NRSEQVENDAMSDE", "DTABERTUR"]
      );
      const missedFields = [];
      const mapKeys = Object.keys(venda);
      try {
        for (const field of fields) {
          if (mapKeys.indexOf(field.name) >= 0) {
            if (field.dbTypeName == "DATE") {
              params[field.name] = venda[field.name]
                ? DateFormat(venda[field.name])
                : null;
            } else {
              params[field.name] = venda[field.name];
            }
          } else {
            missedFields.push(field.name);
          }
        }

        if (missedFields.length) {
          throw {
            error: "true",
            message: `missing fields on ${tabela}`,
            fields: missedFields,
          };
        } else {
          let nrSeqVenda;
          try {
            params["DTEXPVENDA"] = DateFormat();
            params["IDIMPVENDA"] = "S";

            try {
              const paramsVerif = [];
              paramsVerif["P_CDFILIAL"] = params["CDFILIAL"];
              paramsVerif["P_CDCAIXA"] = params["CDCAIXA"];
              paramsVerif["P_DTABERTUR"] = params["DTABERTUR"];
              paramsVerif["P_NRSEQVENDA"] = params["NRSEQVENDAMSDE"];
              const verifVenda = await adqVerifVenda.get(paramsVerif);
              let execution = {};
              if (verifVenda.rows.length > 0) {
                nrSeqVenda = verifVenda.rows[0][2];
                params["NRSEQVENDA"] = nrSeqVenda;
                execution = await OracleService.execute(updateQuery, params);
                await execution.connection.commit();
              } else {
                execution = await OracleService.execute(insertQuery, params);
                await execution.connection.commit();
              }

              await this.InsertItemsVenda(itemsVenda, params["NRSEQVENDA"]);
              await this.InsertItHrComanda(
                itemsHrComanda,
                params["NRSEQVENDA"]
              );
              await this.InsertItVendaImpos(itVendaImpos, params["NRSEQVENDA"]);
              await execution.connection.commit();
            } catch (error) {
              throw error;
            }
          } catch (error) {
            console.log("Erro...", error);
            throw error;
          }
        }
      } catch (error) {
        throw error;
      }
    } catch (error) {
      if (error) {
        throw error;
      }
    }
  }

  async InsertItemsVenda(items, nrseqvenda) {
    for (const item of items) {
      item["NRSEQVENDA"] = nrseqvenda;
      // Até que a regra da pedidofos seja concluída
      item["NRPEDIDOFOS"] = null;
    }
    for (const item of items) {
      try {
        const params = [];
        params["P_CDFILIAL"] = item["CDFILIAL"];
        params["P_CDCAIXA"] = item["CDCAIXA"];
        params["P_NRSEQVENDA"] = item["NRSEQVENDA"];
        params["P_NRSEQUITVEND"] = item["NRSEQUITVEND"];
        const verifItemVenda = await adqVerifItemVenda.get(params);

        items = verifItemVenda.rows.length > 0 ? items.slice(1) : items;
        /*if (verifItemVenda.rows.length > 0) {
          items = items.slice(1);
        }*/
      } catch (error) {
        console.log(error);
      }
    }
    return await TransfDados(
      { data: items, tabela: "ITEMVENDA", autocommit: false },
      true
    );
  }

  async InsertItemsPedidofos(items, nrpedidofos) {
    for (const item of items) {
      item["NRPEDIDOFOS"] = nrpedidofos.substring(-10);
      item["NRSEQVENDA"] = item["NRSEQVENDA"].substring(-10);
    }

    return await TransfDados(
      { data: items, tabela: "ITPEDIDOFOS", autocommit: false },
      true
    );
  }

  async InsertItHrComanda(items, nrseqvenda) {
    for (const item of items) {
      item["NRSEQVENDA"] = nrseqvenda;
      // Até que a regra da pedidofos seja concluída
      item["NRPEDIDOFOS"] = null;
    }
    for (const item of items) {
      const params = [];
      params["P_CDFILIAL"] = item["CDFILIAL"];
      params["P_CDCAIXA"] = item["CDCAIXA"];
      params["P_NRSEQVENDA"] = item["NRSEQVENDA"];
      params["P_NRSEQUITEM"] = item["NRSEQUITEM"];
      const verifItHrComanda = await adqVerifItHrComanda.get(params);

      items = verifItHrComanda.rows.length > 0 ? items.slice(1) : items;

      /*if (verifItHrComanda.rows.length > 0) {
        // retirar item que já tiver sido incluido do objeto items
      }*/
    }
    return await TransfDados(
      { data: items, tabela: "ITHRCOMANDA", autocommit: false },
      true
    );
  }

  async InsertItVendaImpos(items, nrseqvenda) {
    for (const item of items) {
      item["NRSEQVENDA"] = nrseqvenda;
      // Até que a regra da pedidofos seja concluída
      item["NRPEDIDOFOS"] = null;
    }
    try {
      for (const item of items) {
        const params = [];
        params["P_CDFILIAL"] = item["CDFILIAL"];
        params["P_CDCAIXA"] = item["CDCAIXA"];
        params["P_NRSEQVENDA"] = item["NRSEQVENDA"];
        params["P_NRSEQUITVEND"] = item["NRSEQUITVEND"];
        params["P_NRSEQITIMPOS"] = item["NRSEQITIMPOS"];
        const verifItVendaImpos = await adqVerifItVendaImpos.get(params);

        items = verifItVendaImpos.rows.length > 0 ? items.slice(1) : items;

        /*if (verifItVendaImpos.rows.length > 0) {
          // retirar item que já tiver sido incluido do objeto items
        }*/
      }
      return await TransfDados(
        { data: items, tabela: "ITVENDAIMPOS", autocommit: false },
        true
      );
    } catch (error) {
      console.log(error);
    }
  }

  async insertMovCaixaVenda(itemsMovCaixa, nrseqvenda = null) {
    for (const movCaixaVenda of itemsMovCaixa) {
      // arr[idx].NRSEQVENDA = nrseqvenda;
      // Até que a regra da pedidofos seja concluída
      // arr[idx].NRPEDIDOFOS = null
      await this.InsereMovCaixa(movCaixaVenda);
    }

    /// return await TransfDados({ data: items, tabela: 'MOVCAIXA', autocommit: false }, true);
    return true;
  }

  async EditaVenda(venda, cdsVendaTemp) {
    try {
      const params = {
        P_CDFILIAL: venda["CDFILIAL"],
        P_CDCAIXA: venda["CDCAIXA"],
        P_DTABERTUR: DateFormat(venda["DTABERTUR"]),
        P_NRSEQVENDA: venda["NRSEQVENDAMSDE"],
      };
      const adqVerifVendaResult = await adqVerifVenda.get(params);

      if (adqVerifVendaResult.rows.length > 0) {
        const updParams = {};
        const verifyFieldName = (fieldName) => {
          const fields = [
            "IDSITUVENDA",
            "DSOBSCANCUP",
            "CDGRPOCORCANCUP",
            "CDSUPERVISOR",
            "IDSTATUSNFCE",
            "DSOBSSTATUSNFCE",
            "NRPROTOCOLOCANC",
            "DSQRCODENFCE",
            "NRACESSONFCE",
            "NRNOTAFISCALCE",
            "CDSERIESAT",
            "IDTPAMBNFCE",
            "NRLANCTONFCE",
            "NRACESSOCANC",
            "IDXMLSATTRANS",
            "NRENTREGAPEDVND",
            "CDVENDEDOR",
            "DSURLFOTOVEN",
            "IDCHECKEDVEN",
            "DTEMISSAONFCE",
            "DSARQXMLNFCE",
            "DSARQXMLCANCNFCE",
          ];

          return fields.includes(fieldName);
        };

        const registro = {};

        for (const field of adqVerifVendaResult.metaData) {
          if (field.name === "NRSEQVENDA") {
            // Será utilizado na extratocons a ser inserida (registro cancelado)
            registro["NRSEQANT"] = venda["NRSEQVENDA"];
            registro["NRSEQNEW"] = this.getAdqFieldValue(
              adqVerifVendaResult,
              "NRSEQVENDA"
            );
            cdsVendaTemp.data.push(registro);
          } else if (field.name === "DTEXPVENDA") {
            updParams[field.name] = Now();
          } else if (verifyFieldName(field.name)) {
            updParams[field.name] = venda[field.name] || null;

            if (updParams[field.name] && field.name.slice(0, 2) === "DT") {
              updParams[field.name] = DateFormat(updParams[field.name]);
            }
          }
        }

        // update venda here
        updParams["CDFILIAL"] = venda["CDFILIAL"];
        updParams["CDCAIXA"] = venda["CDCAIXA"];
        updParams["NRSEQVENDAMSDE"] = venda["NRSEQVENDA"];

        await editaVendaModel.execute(updParams);

        if (venda["IDSITUVENDA"] === "C") {
          // Cancela o registro na movcaixa
          await this.CancelaMovCaixa(
            venda["CDFILIAL"],
            venda["CDCAIXA"],
            registro["NRSEQNEW"]
          );
          // Cancela o registro na moviclie
          await this.CancelaMoviClie(
            venda["CDFILIAL"],
            venda["CDCAIXA"],
            registro["NRSEQNEW"],
            venda["CDCLIENTE"],
            venda["DTENTRVENDA"]
          );
          // Cancela os benefícios utilizados na movbeneficioctr
          await this.CancelaBeneficio(
            venda["CDFILIAL"],
            venda["CDCAIXA"],
            registro["NRSEQNEW"]
          );
        }
      }

      await OracleService.connection.commit();
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  async CancelaMovCaixa(filial, caixa, nrseqvenda) {
    try {
      const params = {
        P_CDFILIAL: filial,
        P_CDCAIXA: caixa,
        P_NRSEQVENDA: nrseqvenda,
      };

      return acmUpdMovCaixa.get(params);
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  async CancelaMoviClie(filial, caixa, nrSeqVenda, cliente, dataEntrVenda) {
    try {
      // Verifica se a venda é débito consumidor
      let params = {
        P_CDFILIAL: filial,
        P_CDCAIXA: caixa,
        P_NRSEQVENDA: nrSeqVenda,
        P_CDCLIENTE: cliente,
        P_DTENTRVENDA: DateFormat(dataEntrVenda),
      };
      const adqMoviClieResult = await adqMoviClie.get(params);

      // Cancela lançamento da tabela moviclie
      if (adqMoviClieResult.rows.length > 0) {
        params = {
          P_CDFILIAL: this.getAdqFieldValue(adqMoviClieResult, "CDFILIAL"),
          P_CDCAIXA: this.getAdqFieldValue(adqMoviClieResult, "CDCAIXA"),
          P_NRSEQVENDA: this.getAdqFieldValue(adqMoviClieResult, "NRSEQVENDA"),
        };

        await acmUpdUltMoviClie.get(params);

        for (const movClie of adqMoviClieResult.rows) {
          if (!this.getAdqFieldValue(adqMoviClieResult, "CDCONSUMIDOR")) {
            params = {
              P_CDCLIENTE: this.getAdqFieldValue(
                adqMoviClieResult,
                "CDCLIENTE"
              ),
              P_CDCONSUMIDOR: this.getAdqFieldValue(
                adqMoviClieResult,
                "CDCONSUMIDOR"
              ),
              P_NRSEQVENDA: this.getAdqFieldValue(
                adqMoviClieResult,
                "NRSEQVENDA"
              ),
              P_NRSEQMOVCLI: this.getAdqFieldValue(
                adqMoviClieResult,
                "NRSEQMOVCLI"
              ),
              P_VRSALDOCONS:
                this.getAdqFieldValue(adqMoviClieResult, "VRSALDOCONS") +
                this.getAdqFieldValue(adqMoviClieResult, "VRMOVCLI"),
            };
            acmUpdSaldoMoviClie.get(params);
          }
        }
      }
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  getAdqFieldValue(queryResult, fieldName, rowIndex = 0) {
    try {
      if (
        queryResult &&
        queryResult.metaData &&
        queryResult.metaData.length &&
        queryResult.rows &&
        queryResult.rows.length
      ) {
        const columnIndex = queryResult.metaData.findIndex((element) => {
          return element.name === fieldName;
        });

        return queryResult.rows[rowIndex][columnIndex] || null;
      }
      return null;
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  async CancelaBeneficio(filial, caixa, nrSeqVenda) {
    try {
      // Verifica se foram utilizados benefícios na venda
      let params = {
        P_CDFILIAL: filial,
        P_CDCAIXA: caixa,
        P_NRSEQVENDA: nrSeqVenda,
      };
      const adqMovBeneficioConsResult = await adqMovBeneficioCons.get(params);

      if (adqMovBeneficioConsResult.rows.length > 0) {
        for (const beneficio of adqMovBeneficioConsResult) {
          params = {
            P_CDCLIENTE: this.getAdqFieldValue(
              adqMovBeneficioConsResult,
              "CDCLIENTE"
            ),
            P_CDCONSUMIDOR: this.getAdqFieldValue(
              adqMovBeneficioConsResult,
              "CDCONSUMIDOR"
            ),
            P_CDCAMPANHA: this.getAdqFieldValue(
              adqMovBeneficioConsResult,
              "CDCAMPANHA"
            ),
            P_NRSEQPRODCAMP: this.getAdqFieldValue(
              adqMovBeneficioConsResult,
              "NRSEQPRODCAMP"
            ),
            P_NRSEQBENEFICIO: this.getAdqFieldValue(
              adqMovBeneficioConsResult,
              "NRSEQBENEFICIO"
            ),
          };
          acmUpdCancMovBeneficio.get(params);
        }
      }
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  LimpaQrCode(DataSetOrigem) {
    //    Try
    //       //Verifica se existe registro na vendarest
    //       with(adqVerifVendarest, Params) do {
    //          Close();
    //          params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //          //Para pedidos Qrcode o nrvendaresst do oracle � igual ao do MSDE
    //          params['P_NRVENDAREST' ] = DataSetOrigem['NRVENDAREST'];
    //          params['P_NRCOMANDA'   ] = DataSetOrigem['NRCOMANDAVND'];
    //          params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //          params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //          Open();
    //       }
    //       if(!adqVerifVendarest.IsEmpty) {
    //          with(acmUpdVendarest) do {
    //            params['P_CDFILIAL'    ] = adqVerifVendarest['CDFILIAL'];
    //            params['P_CDLOJA'      ] = adqVerifVendarest['CDLOJA'];
    //            params['P_NRVENDAREST' ] = adqVerifVendarest['NRVENDAREST'];
    //            params['P_CDCLIENTE'   ] = adqVerifVendarest['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = adqVerifVendarest['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          {with(acmDelItComandaven) do {      //Limpar tabela itcomandaven
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST' ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_NRCOMANDA'   ] = DataSetOrigem['NRCOMANDAVND'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          with(acmDelComandaven) do {        //Limpar tabela comandaven
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST'   ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_NRCOMANDA'   ] = DataSetOrigem['NRCOMANDAVND'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          with(acmDelMovCaixaDlv) do {       //Limpar tabela movcaixadlv
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST'   ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }
    //          with(acmDelVendarest) do {         //Limpar tabela vendarest
    //            params['P_CDFILIAL'    ] = DataSetOrigem['CDFILIAL'];
    //            params['P_NRVENDAREST'   ] = DataSetOrigem['NRVENDAREST'];
    //            params['P_CDCLIENTE'   ] = DataSetOrigem['CDCLIENTE'];
    //            params['P_CDCONSUMIDOR'] = DataSetOrigem['CDCONSUMIDOR'];
    //            Execute();
    //          }}
    //       }
    //    } catch(error) {
    //    }
  }

  async InsereMovCaixa(movCaixa) {
    try {
      const params = [];
      const tabela = "MOVCAIXA";
      const { insertQuery, updateQuery, fields } = await ConstructQuery(
        "MOVCAIXA",
        ["CDFILIAL", "CDCAIXA", "DTABERCAIX", "NRSEQUMOVIMSDE"]
      );
      const missedFields = [];
      const mapKeys = Object.keys(movCaixa);

      try {
        for (const field of fields) {
          if (mapKeys.indexOf(field.name) >= 0) {
            if (field.dbTypeName === "DATE") {
              params[field.name] = movCaixa[field.name]
                ? DateFormat(movCaixa[field.name])
                : null;
            } else {
              params[field.name] = movCaixa[field.name];
            }
          } else {
            missedFields.push(field.name);
          }
        }

        if (missedFields.length) {
          throw {
            error: "true",
            message: `missing fields on ${tabela}`,
            fields: missedFields,
          };
        } else {
          try {
            try {
              let paramsVerif = [];
              paramsVerif["P_CDFILIAL"] = params["CDFILIAL"];
              paramsVerif["P_CDCAIXA"] = params["CDCAIXA"];
              paramsVerif["P_DTABERCAIX"] = params["DTABERCAIX"];
              paramsVerif["P_NRSEQUMOVI"] = params["NRSEQUMOVI"];

              const verifMovCaixa = await adqVerifMovCaixa.get(paramsVerif);

              let execution = {};

              // Lincoln (Send MOVCAIXA rows with type 'A' and 'G') - begin
              if (
                movCaixa.IDTIPOMOVIVE !== "A" &&
                movCaixa.IDTIPOMOVIVE !== "G" &&
                movCaixa.NRSEQVENDA
              ) {
                // VERIFICAÇÃO DA VENDA
                paramsVerif = [];
                paramsVerif["P_CDFILIAL"] = params["CDFILIAL"];
                paramsVerif["P_CDCAIXA"] = params["CDCAIXA"];
                paramsVerif["P_DTABERTUR"] = params["DTABERCAIX"];
                paramsVerif["P_NRSEQVENDA"] = movCaixa["NRSEQVENDA"];

                const verifVenda = await adqVerifVenda.get(paramsVerif);

                if (verifVenda.rows.length > 0) {
                  params["NRSEQVENDA"] = verifVenda.rows[0][2];
                } else {
                  return;
                }
              }

              if (verifMovCaixa.rows.length > 0) {
                execution = await OracleService.execute(updateQuery, params);
                execution.connection.commit();
              } else {
                try {
                  params["NRSEQUMOVI"] = await GeraNovoCodigo.prxMovCaixa(
                    params["CDFILIAL"],
                    params["CDCAIXA"],
                    params["DTABERCAIX"]
                  );

                  execution = await OracleService.execute(insertQuery, params);
                  execution.connection.commit();
                } catch (error) {
                  console.log(error);
                }
              }
              return true;
            } catch (error) {
              console.log(error);
              throw error;
            }
          } catch (error) {
            throw error;
          }
        }
      } catch (error) {
        throw error;
      }
    } catch (error) {
      if (error) {
        console.log("Deu erro... ");
        console.log(error);
        throw error;
      }
    }
  }

  AtualizaPedidoFos(pedidos, itemsPedidos) {
    pedidos.data.forEach((pedidofos) => {
      const itemsPedidoAtual = itemsPedidos.data.filter(
        (it) => it.NRPEDIDOFOS === pedidofos.NRPEDIDOFOS
      );
      try {
        this.InserePedidoFos(pedidofos, itemsPedidoAtual);
      } catch (error) {
        throw error;
      }
    });
  }

  async InserePedidoFos(pedido, itemsPedido) {
    const params = [];
    let paramsVerif = [];
    let nrpedidofos;
    let execution = {};
    let VerifPedido = {};
    const { insertQuery, updateQuery, fields } = await ConstructQuery(
      "PEDIDOFOS",
      ["CDFILIAL", "NRPEDIDOFOSMSDE", "DTPEDIDOFOS"]
    );
    const missedFields = [];
    const mapKeys = Object.keys(pedido);

    try {
      fields.forEach((field) => {
        if (!mapKeys.indexOf(field.name)) {
          if (field.dbTypeName === "DATE") {
            params[field.name] = pedido[field.name]
              ? DateFormat(pedido[field.name])
              : null;
          } else {
            params[field.name] = pedido[field.name];
          }
        } else {
          missedFields.push(field.name);
        }
      });

      if (missedFields.length) {
        throw {
          error: "true",
          message: `missing fields on ${tabela}`,
          fields: missedFields,
        };
      } else {
        paramsVerif = [];
        paramsVerif["P_CDFILIAL"] = params["CDFILIAL"];
        paramsVerif["P_NRPEDIDOFOS"] = params["NRPEDIDOFOS"];
        paramsVerif["P_DTPEDIDOFOS"] = params["DTPEDIDOFOS"];

        try {
          VerifPedido = await adqVerifPedidoFos.get(paramsVerif);
        } catch (error) {}
        if (VerifPedido.rows.length > 0) {
          params["NRPEDIDOFOSMSDE"] = VerifPedido.rows[0][1];
          nrpedidofos = VerifPedido.rows[0][1];
          execution = await OracleService.execute(updateQuery, params);
        } else {
          // params['NRPEDIDOFOS'] = VerifPedido.rows[0][1]
          // Faz o que tem de fazer aqui

          // Faz o que tem de fazer aqui
          execution = await OracleService.execute(insertQuery, params);
          paramsVerif = [];
          paramsVerif["P_CDFILIAL"] = params["CDFILIAL"];
          paramsVerif["P_NRPEDIDOFOS"] = params["NRPEDIDOFOS"];
          paramsVerif["P_DTPEDIDOFOS"] = params["DTPEDIDOFOS"];
          try {
            VerifPedido = await adqVerifPedidoFos.get(paramsVerif);
          } catch (error) {}
          nrpedidofos = VerifPedido.rows[0][1];
        }

        await this.InsertItemsPedidofos(itemsPedido, nrpedidofos);
        execution.connection.commit();
      }
    } catch (error) {}
    // executa insert
    // pega o nrpedidofos gerado através do nrpedidofos
    // executa insert dos items
    // commit ou rollback
  }

  async VerificaPedidoFos() {
    if (!this.cdsCliPedidoFos) {
      return false;
    }
    for (const pedidofos of this.cdsCliPedidoFos.data) {
      const params = [];
      params["P_CDFILIAL"] = this.cdsCliPedidoFos["CDFILIAL"];
      params["P_NRPEDIDOFOS"] = this.cdsCliPedidoFos["NRPEDIDOFOS"]; // NRPEDIDOFOSMSDE
      params["P_DTPEDIDOFOS"] = this.cdsCliPedidoFos["DTPEDIDOFOS"];
      const adqVerifPedidoFos_result = await adqVerifPedidoFos.get(params);

      const stIdSituacao = adqVerifPedidoFos_result.length ? "OK" : "NOK";
      const retPedidoFos = {};
      retPedidoFos["CDFILIAL"] = pedidofos["CDFILIAL"];
      retPedidoFos["NRPEDIDOFOS"] = pedidofos["NRPEDIDOFOS"];
      retPedidoFos["IDSITUACAO"] = stIdSituacao;
      cdsRetPedidoFos.data.push(retPedidoFos);
    }
  }

  async verificaLogOperFos() {
    if (!this.cdsLOGOPERFOS) {
      return false;
    }
    for (const logOperFos of this.cdsLOGOPERFOS.data) {
      const params = [];
      params["P_CDFILIAL"] = logOperFos["CDFILIAL"];
      params["P_CDCAIXA"] = logOperFos["CDCAIXA"];
      params["P_IDOPERFOS"] = logOperFos["IDOPERFOS"];
      params["P_CDOPERRESPOP"] = logOperFos["CDOPERRESPOP"];
      params["P_DTHROPERFOS"] = DateFormat(logOperFos["DTHROPERFOS"]);
      const adqVerifLogOperFos_result = await adqVerifLogOperFos.get(params);

      const stIdSituacao = adqVerifLogOperFos_result.rows.length ? "OK" : "NOK";
      const retLogOperFos = {};
      retLogOperFos["CDFILIAL"] = logOperFos["CDFILIAL"];
      retLogOperFos["CDCAIXA"] = logOperFos["CDCAIXA"];
      retLogOperFos["IDOPERFOS"] = logOperFos["IDOPERFOS"];
      retLogOperFos["CDOPERRESPOP"] = logOperFos["CDOPERRESPOP"];
      retLogOperFos["DTHROPERFOS"] = logOperFos["DTHROPERFOS"];
      retLogOperFos["IDSITUACAO"] = stIdSituacao;

      cdsRetLogOperFos.data.push(retLogOperFos);
    }
  }

  async VerificaLogAcesso() {
    if (this.cdsCliLOGACESSO) {
      for (const logAcesso of this.cdsCliLOGACESSO.data) {
        const params = [];
        params["P_CDOPERADOR"] = logAcesso["CDOPERADOR"];
        params["P_DSSISTEMA"] = logAcesso["DSSISTEMA"];
        params["P_DTHRACESSO"] = DateFormat(logAcesso["DTHRACESSO"]);
        const adqVerifLogAcesso_result = await adqVerifLogAcesso.get(params);

        const stIdSituacao = adqVerifLogAcesso_result.rows.length
          ? "OK"
          : "NOK";
        const retLogAcesso = {};
        retLogAcesso["CDOPERADOR"] = logAcesso["CDOPERADOR"];
        retLogAcesso["DSSISTEMA"] = logAcesso["DSSISTEMA"];
        retLogAcesso["DTHRACESSO"] = logAcesso["DTHRACESSO"];
        retLogAcesso["IDSITUACAO"] = stIdSituacao;

        cdsRetLogAcesso.data.push(retLogAcesso);
      }
    }
  }

  async atualizaConsumidor(clientDataSet) {
    if (clientDataSet.data.length) {
      for (const consumidor of clientDataSet.data) {
        if (consumidor["IDATUCONSUMI"] === "I") {
          InfoLogger.write(
            `${consumidor["CDFILIAL"]} ${consumidor["CDCAIXA"]} AtualizaConsumidor > InsereConsumidor`,
            consumidor["CDFILIAL"]
          );
          await this.insereConsumidor(consumidor);
        } else {
          InfoLogger.write(
            `${consumidor["CDFILIAL"]} ${consumidor["CDCAIXA"]} AtualizaConsumidor > EditaConsumidor`,
            consumidor["CDFILIAL"]
          );
          await this.editaConsumidor(consumidor);
        }
      }
    }
  }

  async insereConsumidor(consumidor) {
    // Verifica se o consumidor existe no servidor
    const params = {
      P_CDCLIENTE: consumidor["CDCLIENTE"],
      P_CDCONSUMIDOR: consumidor["CDCONSUMIDOR"],
    };
    const resultadoQuery = await this.abreQuery(adqVerifConsumidor, params);

    // Caso o consumidor não exista
    if (!resultadoQuery.length) {
      try {
        const { insertQuery, fields } = await ConstructQuery("CONSUMIDOR", [
          "CDCLIENTE",
          "CDCONSUMIDOR",
        ]);

        const novoConsumidor = {};

        for (const field of fields) {
          if (field.name === "IDATUCONSUMI") {
            novoConsumidor[field.name] = "S";
          } else if (field.name === "DTULTATUCSUM") {
            novoConsumidor[field.name] = DateFormat(new Date());
          } else if (field.dbTypeName === "VARCHAR2") {
            novoConsumidor[field.name] = consumidor[field.name] || null;
          } else if (field.dbTypeName === "DATE") {
            novoConsumidor[field.name] = consumidor[field.name]
              ? DateFormat(consumidor[field.name])
              : null;
          } else {
            novoConsumidor[field.name] = consumidor[field.name];
          }
        }

        await OracleService.execute(insertQuery, novoConsumidor);
      } catch (error) {
        console.log(error);
      }
    }
  }

  async editaConsumidor(consumidor) {
    const params = {
      P_CDCLIENTE: consumidor["CDCLIENTE"],
      P_CDCONSUMIDOR: consumidor["CDCONSUMIDOR"],
    };
    const adqSrvUpdConsumidorResult = await adqSrvUpdConsumidor.get(params);

    if (adqSrvUpdConsumidorResult.rows.length) {
      const { updateQuery, fields } = await ConstructQuery("CONSUMIDOR", [
        "CDCLIENTE",
        "CDCONSUMIDOR",
      ]);

      const novoConsumidor = {};

      for (const field of fields) {
        if (field.name === "IDATUCONSUMI") {
          novoConsumidor[field.name] = "S";
        } else if (field.name === "DTULTATUCSUM") {
          novoConsumidor[field.name] = DateFormat(new Date());
        } else if (field.dbTypeName === "VARCHAR2") {
          novoConsumidor[field.name] = consumidor[field.name] || null;
        } else if (field.dbTypeName === "DATE") {
          novoConsumidor[field.name] = consumidor[field.name]
            ? DateFormat(consumidor[field.name])
            : null;
        } else {
          novoConsumidor[field.name] = consumidor[field.name];
        }
      }

      await OracleService.execute(updateQuery, novoConsumidor);
    }
  }

  async abreQuery(query, params) {
    if (query) {
      return query.get(params).then((resultado) => {
        return resultado.rows;
      });
    }

    return null;
  }

  async atualizaExtratoCons(cdsCliExtratoCons, cdsVendaTemp) {
    const cliConsExtrato = new ClientDataSet([]);

    for (const extratoCons of cdsCliExtratoCons.data) {
      const cdCliente = extratoCons["CDCLIENTE"];
      const cdConsumidor = extratoCons["CDCONSUMIDOR"];
      const cdFamiliaSaldo = extratoCons["CDFAMILISALD"];
      const dtInicioEvol = Now();
      const encontrou = cliConsExtrato.locate(
        ["CDCLIENTE", "CDCONSUMIDOR", "CDFAMILISALD"],
        [cdCliente, cdConsumidor, cdFamiliaSaldo]
      );

      console.log(cdsCliExtratoCons.data);

      if (!encontrou) {
        const registro = {
          CDCLIENTE: cdCliente,
          CDCONSUMIDOR: cdConsumidor,
          CDFAMILISALD: cdFamiliaSaldo,
        };

        if (dtInicioEvol > extratoCons["DTMOVEXTCONS"]) {
          registro["DTMOVEXTCONS"] = extratoCons["DTMOVEXTCONS"];
        } else {
          registro["DTMOVEXTCONS"] = dtInicioEvol;
        }

        cliConsExtrato.data.push(registro);
      }

      console.log(cliConsExtrato.data);

      const adqSrvExtratoConsResult = await adqSrvExtratoCons.get({
        P_CDCLIENTE: extratoCons["CDCLIENTE"],
        P_CDCONSUMIDOR: extratoCons["CDCONSUMIDOR"],
        P_CDFAMILISALD: extratoCons["CDFAMILISALD"],
        P_DTMOVEXTCONS: DateFormat(extratoCons["DTMOVEXTCONS"]),
        P_NRSEQMOVEXT: extratoCons["NRSEQMOVEXT"],
      });

      console.log(extratoCons);
      try {
        await this.insereExtratoCons(
          extratoCons,
          adqSrvExtratoConsResult.rows,
          "",
          cdsVendaTemp
        );
        await acmUpdExtratoCons.get();
      } catch (error) {
        console.log(error);
      }
    }

    for (const extratoCons of cliConsExtrato.data) {
      const params = {
        P_CDCLIENTE: extratoCons["CDCLIENTE"],
        P_CDCONSUMIDOR: extratoCons["CDCONSUMIDOR"],
        P_CDFAMILISALD: extratoCons["CDFAMILISALD"],
        P_DTINIEVOLUCAO: DateFormat(extratoCons["DTMOVEXTCONS"]),
      };
      const adqMinDtMovExtConsResult = await adqMinDtMovExtCons.get(params);
      const dtMovExtCons = new Date(adqMinDtMovExtConsResult.rows[0][0]);
      const milisegundosPorDia = 86400000;

      let dtInicioEvol = 0;

      if (dtMovExtCons.getTime === 0) {
        dtInicioEvol = DateFormat(extratoCons["DTMOVEXTCONS"]);
        dtInicioEvol = new Date(dtInicioEvol).getTime();
        dtInicioEvol -= milisegundosPorDia * 60;
        dtInicioEvol = new Date(dtInicioEvol);
      } else {
        dtInicioEvol = new Date(
          dtMovExtCons.getTime() - milisegundosPorDia * 60
        );
      }

      const atualizaSaldoParams = [
        {name: 'P_CDCLIENTE', value: extratoCons["CDCLIENTE"]},
        {name: 'P_CDCONSUMIDOR', value: extratoCons["CDCONSUMIDOR"]},
        {name: 'P_CDFAMILISALD', value: extratoCons["CDFAMILISALD"]},
        {name: 'P_DTINIEVOLUCAO', value: dtInicioEvol},
      ];

      try {
        console.log("ATUALIZA_SALDO_CONS_FKB = " + atualizaSaldoParams);
        await OracleService.execProcedure(
          "ATUALIZA_SALDO_CONS_FKB",
          atualizaSaldoParams
        );
      } catch (error) {
        console.log(error);
      }
    }
  }

  async insereExtratoCons(
    dataSetOrigem,
    dataSetDestino,
    nrSeqVenda,
    cdsVendaTemp
  ) {
    const novoRegistro = {};
    const campos = Object.keys(dataSetOrigem);

    const { insertQuery, fields } = await ConstructQuery("EXTRATOCONS", [
      "CDCLIENTE",
      "CDCONSUMIDOR",
      "CDFAMILISALD",
      "DTMOVEXTCONS",
      "NRSEQMOVEXT",
    ]);

    for (const field of fields) {
      if (field.name === "NRSEQVENDA" && dataSetOrigem[field]) {
        if (!nrSeqVenda) {
          const registro = cdsVendaTemp.locate(
            ["NRSEQANT"],
            [dataSetOrigem[field]]
          );
          novoRegistro[field.name] = registro["NRSEQNEW"];
        } else {
          novoRegistro[field.name] = nrSeqVenda;
        }
      } else if (field.name === "IDIMPEXTRATO") {
        novoRegistro[field.name] = "S";
      } else if (field.dbTypeName === "VARCHAR2") {
        novoRegistro[field.name] = dataSetOrigem[field.name] || null;
      } else if (field.dbTypeName === "DATE") {
        novoRegistro[field.name] = dataSetOrigem[field.name]
          ? DateFormat(dataSetOrigem[field.name])
          : null;
      } else {
        novoRegistro[field.name] = dataSetOrigem[field.name];
      }
    }

    InfoLogger.write(
      `comando: ${insertQuery} valores: ${novoRegistro}`,
      dataSetOrigem["CDFILIAL"]
    );
    try {
      await OracleService.execute(insertQuery, novoRegistro);
    } catch (error) {
      console.log(error);
    }
    // Cancelamento da carga de crédito
    if (dataSetOrigem["IDTPMOVEXT"] === "D" && !dataSetOrigem["NRSEQVENDA"]) {
      await acmCancMovCaixa.get({
        P_CDFILIAL: dataSetOrigem["CDFILIAL"],
        P_CDCAIXA: dataSetOrigem["CDCAIXA"],
        P_DTABERCAIX: dataSetOrigem["DTABERCAIX"],
        P_NRSEQUMOVI: dataSetOrigem["NRSEQUMOVI"],
      });
    }
  }

  async verificaExtratoCons(tuplasExtratoConsMSDE) {
    const cdsRetExtratoCons = new ClientDataSet([]);

    for (const tupla of tuplasExtratoConsMSDE.data) {
      const {
        CDCLIENTE: cdCliente,
        CDCONSUMIDOR: cdConsumidor,
        CDFAMILISALD: cdFamiliSald,
        DTMOVEXTCONS: dtMovExtCons,
        NRSEQMOVEXT: nrSeqMovExt,
      } = tupla;
      const params = {
        P_CDCLIENTE: cdCliente,
        P_CDCONSUMIDOR: cdConsumidor,
        P_CDFAMILISALD: cdFamiliSald,
        P_DTMOVEXTCONS: dtMovExtCons,
        P_NRSEQMOVEXT: nrSeqMovExt,
      };
      const adqSrvExtratoConsResult = adqSrvExtratoCons
        .get(params)
        .then((resultado) => resultado.rows[0])
        .catch(() => null);
      const idSituacao = adqSrvExtratoConsResult ? "OK" : "NOK";
      cdsRetExtratoCons.data.push({
        CDCLIENTE: cdCliente,
        CDCONSUMIDOR: cdConsumidor,
        CDFAMILISALD: cdFamiliSald,
        DTMOVEXTCONS: dtMovExtCons,
        NRSEQMOVEXT: nrSeqMovExt,
        IDSITUACAO: idSituacao,
      });
    }

    return cdsRetExtratoCons;
  }

  async consisteExtratoCons(cdsCliExtratoCons, cdsCliTurCaixa, cdsCliVenda) {
    for (const extratoCons of cdsCliExtratoCons.data) {
      const {
        CDFILIAL: cdFilial,
        CDCAIXA: cdCaixa,
        DTABERCAIX: dtAberCaix,
      } = extratoCons;
      const params = {
        P_CDFILIAL: cdFilial,
        P_CDCAIXA: cdCaixa,
        P_DTABERCAIX: DateFormat(dtAberCaix),
      };
      const adqVerifTurCaixaResult = await adqVerifTurCaixa.get(params);

      if (!adqVerifTurCaixaResult.rows.length) {
        if (
          !cdsCliTurCaixa.locate(
            ["CDFILIAL", "CDCAIXA", "DTABERCAIX"],
            [cdFilial, cdCaixa, dtAberCaix]
          )
        ) {
          cdsCliExtratoCons.delete(
            ["CDFILIAL", "CDCAIXA", "DTABERCAIX"],
            [cdFilial, cdCaixa, dtAberCaix]
          );
          console.log("deletou. Atual: " + cdsCliExtratoCons.data);
        }
      }
    }

    const registrosComVenda = new ClientDataSet(
      cdsCliExtratoCons.data.filter((element) => {
        return element["NRSEQVENDA"];
      })
    );

    for (const registro of registrosComVenda.data) {
      const {
        CDFILIAL: cdFilial,
        CDCAIXA: cdCaixa,
        NRSEQVENDA: nrSeqVenda,
      } = registro;

      if (
        !cdsCliVenda.locate(
          ["CDFILIAL", "CDCAIXA", "NRSEQVENDA"],
          [cdFilial, cdCaixa, nrSeqVenda]
        )
      ) {
        console.log(cdsCliVenda.data);
        registrosComVenda.delete(
          [
            "CDCLIENTE",
            "CDCONSUMIDOR",
            "CDFAMILISALD",
            "DTMOVEXTCONS",
            "NRSEQMOVEXT",
          ],
          [
            registro["CDCLIENTE"],
            registro["CDCONSUMIDOR"],
            registro["CDFAMILISALD"],
            registro["DTMOVEXTCONS"],
            registro["NRSEQMOVEXT"],
          ]
        );
      }
    }
  }

  async atualizaMoviClie(cdFilial) {
    const params = {
      P_CDFILIAL: cdFilial,
    };
    const qryAtualizaMoviClieResult = await this.abreQuery(
      qryAtualizaMoviClie,
      params
    );

    // Verificado o campo da ParaVend se o mesmo estiver 'N' ao updatar a moviclie grava com 'S' e
    // Verificado o campo da ParaVend se o mesmo estiver 'S' ao updatar a moviclie grava com 'N' onde estes dados não serão mais baixados no msde.
    // sol.116451
    params["P_IDBXMOVICLIE"] = qryAtualizaMoviClieResult[0] === "N" ? "S" : "N";
    params["P_IDBXVENDACAT"] = "S";

    await acmUpdMoviClie.get(params);
  }

  async editaTotalDiaCaixa(totalDiaCaixa, insertQuery, updateQuery, fields) {
    try {
      const params = {};

      fields.forEach((field) => {
        if (field.name === "IDIMPTOTDIACAIXA") {
          params[field.name] = "S";
        } else if (field.dbTypeName === "DATE") {
          params[field.name] = DateFormat(totalDiaCaixa[field.name]);
        } else {
          params[field.name] = totalDiaCaixa[field.name] || null;
        }
      });

      const { rows } = await adqVerifTotalDiaCaixa.get({
        P_CDFILIAL: totalDiaCaixa["CDFILIAL"],
        P_CDCAIXA: totalDiaCaixa["CDCAIXA"],
        P_DTTOTAL: DateFormat(totalDiaCaixa["DTTOTAL"]),
      });

      if (rows && rows.length) {
        await OracleService.execute(updateQuery, params);
      } else {
        await OracleService.execute(insertQuery, params);
      }
    } catch (error) {
      InfoLogger.write(
        `${totalDiaCaixa["CDFILIAL"]} ${totalDiaCaixa["CDCAIXA"]} EditaTotalDiaCaixa exception: ${error}`,
        totalDiaCaixa["CDFILIAL"]
      );
    }
  }

  async atualizaTotalDiaCaixa(cdsCliTotalDiaCaixa) {
    const { insertQuery, updateQuery, fields } = await ConstructQuery(
      "TOTALDIACAIXA",
      ["CDFILIAL", "CDCAIXA", "DTTOTAL"]
    );

    for (const totalDiaCaixa of cdsCliTotalDiaCaixa.data) {
      InfoLogger.write(
        `${totalDiaCaixa["CDFILIAL"]} ${totalDiaCaixa["CDCAIXA"]} AtualizaTotalDiaCaixa > EditaTotalDiaCaixa`,
        totalDiaCaixa["CDFILIAL"]
      );
      await this.editaTotalDiaCaixa(
        totalDiaCaixa,
        insertQuery,
        updateQuery,
        fields
      );
    }
  }

  async atualizaExtratoConsPend(cdsCliExtratoConsPend, cdsVendaTemp) {
    for (const extratoConsPend of cdsCliExtratoConsPend.data) {
      let dtInicEvol = new Date();
      const adqSrvExtratoConsResult = await adqSrvExtratoCons.get({
        P_CDCLIENTE: extratoConsPend["CDCLIENTE"],
        P_CDCONSUMIDOR: extratoConsPend["CDCONSUMIDOR"],
        P_CDFAMILISALD: extratoConsPend["CDFAMILISALD"],
        P_DTMOVEXTCONS: DateFormat(extratoConsPend["DTMOVEXTCONS"]),
        P_NRSEQMOVEXT: extratoConsPend["NRSEQMOVEXT"],
      });
      const adqVerifVendaResult = await adqVerifVenda.get({
        P_CDFILIAL: extratoConsPend["CDFILIAL"],
        P_CDCAIXA: extratoConsPend["CDCAIXA"],
        P_DTABERTUR: DateFormat(extratoConsPend["DTABERCAIX"]),
        P_NRSEQVENDA: extratoConsPend["NRSEQVENDA"],
      });

      if (
        !adqSrvExtratoConsResult.rows.length &&
        adqVerifVendaResult.rows.length
      ) {
        await this.insereExtratoCons(extratoConsPend, null, "", cdsVendaTemp);

        const dtExtratoConsPend = new Date(extratoConsPend["DTMOVEXTCONS"]);

        if (dtInicEvol.getTime() > dtExtratoConsPend.getTime()) {
          dtInicEvol = dtExtratoConsPend;
        }
      }

      await acmUpdExtratoCons.get();
      await this.evoluiSaldo(
        extratoConsPend["CDCLIENTE"],
        extratoConsPend["CDCONSUMIDOR"],
        dtInicEvol
      );
    }
  }

  async evoluiSaldo(cdCliente, cdConsumidor, dtInicEvol) {
    let params = {
      P_CDCLIENTE: cdCliente,
      P_TCDCLIENTE: cdCliente ? "" : "T",
      P_CDCONSUMIDOR: cdConsumidor,
      P_TCDCONS: cdConsumidor ? "" : "T",
      P_DTMOVEXTCONS: DateFormat(dtInicEvol),
    };

    const adqUltMovExtResult = await adqUltMovExt.get(params);

    for (let i = 0; i < adqUltMovExtResult.rows.length; i += 1) {
      params = {
        P_CDCLIENTE: this.getAdqFieldValue(adqUltMovExtResult, "CDCLIENTE", i),
        P_CDCONSUMIDOR: this.getAdqFieldValue(
          adqUltMovExtResult,
          "CDCONSUMIDOR",
          i
        ),
        P_DTMOVEXTCONS: DateFormat(
          this.getAdqFieldValue(adqUltMovExtResult, "DTMOVEXTCONS", i)
        ),
        P_CDFAMILISALD: this.getAdqFieldValue(
          adqUltMovExtResult,
          "CDFAMILISALD",
          i
        ),
      };

      const adqMovExtratoResult = await adqMovExtrato.get(params);
      const idTpMovExt = this.getAdqFieldValue(
        adqMovExtratoResult,
        "IDTPMOVEXT",
        0
      );
      const vrMovExtCons = this.getAdqFieldValue(
        adqMovExtratoResult,
        "VRMOVEXTCONS",
        0
      );
      const vrSaldConExt = this.getAdqFieldValue(
        adqUltMovExtResult,
        "VRSALDCONEXT",
        i
      );
      let vrSaldAtu = "";

      if (idTpMovExt === "C" || idTpMovExt === "F") {
        vrSaldAtu = vrSaldConExt + vrMovExtCons;
      } else {
        vrSaldAtu = vrSaldConExt - vrMovExtCons;
      }

      vrSaldAtu = vrSaldAtu.toFixed(2);

      for (let j = 0; j < adqMovExtratoResult.rows.length; j += 1) {
        params = {
          CDCLIENTE: this.getAdqFieldValue(adqMovExtratoResult, "CDCLIENTE", j),
          CDCONSUMIDOR: this.getAdqFieldValue(
            adqMovExtratoResult,
            "CDCONSUMIDOR",
            j
          ),
          CDFAMILISALD: this.getAdqFieldValue(
            adqMovExtratoResult,
            "CDFAMILISALD",
            j
          ),
          DTMOVEXTCONS: DateFormat(
            this.getAdqFieldValue(adqMovExtratoResult, "DTMOVEXTCONS", j)
          ),
          NRSEQMOVEXT: this.getAdqFieldValue(
            adqMovExtratoResult,
            "NRSEQMOVEXT",
            j
          ),
          VRSALDCONEXT: this.getAdqFieldValue(
            adqMovExtratoResult,
            "VRSALDCONEXT",
            j
          ),
        };

        await acmUpMovExtrato.get(params);

        if (j < adqMovExtratoResult.rows.length) {
          if (idTpMovExt === "C" || idTpMovExt === "F") {
            vrSaldAtu += vrMovExtCons;
          } else {
            vrSaldAtu -= vrMovExtCons;
          }
        }
      }

      // Atualiza SALDO
      if (adqMovExtratoResult.rows.length) {
        params = {
          CDCLIENTE: this.getAdqFieldValue(adqMovExtratoResult, "CDCLIENTE", 0),
          CDCONSUMIDOR: this.getAdqFieldValue(
            adqMovExtratoResult,
            "CDCONSUMIDOR",
            0
          ),
          CDFAMILISALD: this.getAdqFieldValue(
            adqMovExtratoResult,
            "CDFAMILISALD",
            0
          ),
        };

        const adqVerifSaldFamiResult = await adqVerifSaldFami.get(params);
        params = {
          CDCLIENTE: this.getAdqFieldValue(adqMovExtratoResult, "CDCLIENTE", 0),
          CDCONSUMIDOR: this.getAdqFieldValue(
            adqMovExtratoResult,
            "CDCONSUMIDOR",
            0
          ),
          CDFAMILISALD: this.getAdqFieldValue(
            adqMovExtratoResult,
            "CDFAMILISALD",
            0
          ),
          VRSALDCONFAM: vrSaldAtu,
        };

        if (adqVerifSaldFamiResult.rows && adqVerifSaldFamiResult.rows.length) {
          await acmUpSaldo.get(params);
        } else {
          await acmInsSaldFami.get(params);
        }
      }
    }
  }

  async atualizaRelatorioVendas(cdsCliRelVendas) {
    if (cdsCliRelVendas.data.length) {
      const connection = await OracleService.getNewConnection();

      try {
        for (const relVendas of cdsCliRelVendas.data) {
          let params = {
            P_CDFILIAL: relVendas["CDFILIAL"],
            P_CDCAIXA: relVendas["CDCAIXA"],
            P_DTENTRVENDA: DateFormat(relVendas["DTENTRVENDA"]),
          };

          const adqVerifRelVendasResult = await adqVerifRelVendas.get(params);
          const adqQtdeVendasOracleResult = await adqQtdeVendasOracle.get(
            params
          );

          params = {
            CDFILIAL: relVendas["CDFILIAL"],
            CDCAIXA: relVendas["CDCAIXA"],
            DTENTRVENDA: DateFormat(relVendas["DTENTRVENDA"]),
            QTVENDASMSDE: relVendas["QTVENDASMSDE"],
            QTVENDASORACLE: this.getAdqFieldValue(
              adqQtdeVendasOracleResult,
              "QTVENDASORACLE"
            ),
            VRTOTMSDE: relVendas["VRTOTMSDE"],
            VRTOTORACLE: this.getAdqFieldValue(
              adqQtdeVendasOracleResult,
              "VRTOTORACLE"
            ),
            DTULTATU: DateFormat(new Date()),
          };

          if (!adqVerifRelVendasResult.rows.length) {
            await acmInsRelVendas.get(params, connection);
          } else {
            await acmUpdRelVendas.get(params, connection);
          }
        }

        await connection.commit();
      } catch (error) {
        if (connection) {
          await connection.rollback();
        }

        console.log(error);
      }
    }
  }

  async corrigeItVendaImpos(cdFilial, cdCaixa) {
    try {
      const params = {
        P_CDFILIAL: cdFilial,
      };
      await acmCorrigeICMS.get(params);
      await acmCorrigePIS.get(params);
      await acmCorrigeCOFINS.get(params);
    } catch (error) {
      InfoLogger.write(
        `${cdFilial} ${cdCaixa} CorrigeItVendaImpos exception: ${error}`,
        cdFilial
      );
      console.log(error);
    }
  }

  async apagaVendasDuplicadas(cdsCliVenda) {
    if (cdsCliVenda.data.length) {
      const cdFilial = cdsCliVenda.data[0]["CDFILIAL"];
      const cdCaixa = cdsCliVenda.data[0]["CDCAIXA"];

      try {
        const dtEntrVenda = new Date(cdsCliVenda.data[0]["DTENTRVENDA"]);
        dtEntrVenda.setDate(dtEntrVenda.getDate() - 2);
        const params = {
          P_CDFILIAL: cdFilial,
          P_CDCAIXA: cdCaixa,
          P_DTENTRVENDA: DateFormat(dtEntrVenda),
        };
        await acmApagaVendasDup.get(params);
      } catch (error) {
        InfoLogger.write(
          `${cdFilial} ${cdCaixa} ApagaVendasDuplicadas exception: ${error}`,
          cdFilial
        );
        console.log(error);
      }
    }
  }

  async apagaSangriaDuplicada(cdsCliMovCaixa) {
    if (cdsCliMovCaixa.data.length) {
      const cdFilial = cdsCliMovCaixa.data[0]["CDFILIAL"];
      const cdCaixa = cdsCliMovCaixa.data[0]["CDCAIXA"];

      try {
        const dtMovCaixa = new Date(cdsCliMovCaixa.data[0]["DTMOVIMCAIXA"]);
        dtMovCaixa.setDate(dtMovCaixa.getDate() - 2);
        const params = {
          P_CDFILIAL: cdFilial,
          P_CDCAIXA: cdCaixa,
          P_DTMOVIMCAIXA: DateFormat(dtMovCaixa),
        };
        await acmApagaSangriaDup.get(params);
      } catch (error) {
        InfoLogger.write(
          `${cdFilial} ${cdCaixa} ApagaSangriaDuplicada exception: ${error}`,
          cdFilial
        );
        console.log(error);
      }
    }
  }

  async verificaConsumidor(cdsCliConsumidor) {
    const cdsRetConsumidor = new ClientDataSet();
    for (const consumidorFos of cdsCliConsumidor.data) {
      const params = {
        P_CDCLIENTE: consumidorFos["CDCLIENTE"],
        P_CDCONSUMIDOR: consumidorFos["CDCONSUMIDOR"],
      };
      let idSituacao;
      const adqVerifConsumidorResult = await adqVerifConsumidorModel.get(
        params
      );

      if (consumidorFos["IDATUCONSUMI"] === "I") {
        //inclusão
        idSituacao = !adqVerifConsumidorResult.rows.length ? "NOK" : "OK";
      } else {
        const dataSQLConsumidor = new Date(consumidorFos["DTULTATUCSUM"]);
        const dataOracleConsumidor = new Date(
          adqVerifConsumidorResult.rows[0][2]
        );
        idSituacao =
          dataSQLConsumidor.getTime() < dataOracleConsumidor.getTime()
            ? "OK"
            : "NOK";
      }
      const dadosConsumidor = {
        CDCLIENTE: consumidorFos["CDCLIENTE"],
        CDCONSUMIDOR: consumidorFos["CDCONSUMIDOR"],
        IDSITUACAO: idSituacao,
      };

      cdsRetConsumidor.data.push(dadosConsumidor);
    }
    return cdsRetConsumidor;
  }

  async insereItPedidoFos(cdsCliItPedidoFos, cdsPedidoFosTemp, cdsVendaTemp) {
    if (cdsCliItPedidoFos.data.length) {
      try {
        const { insertQuery, fields } = await ConstructQuery("ITPEDIDOFOS", [
          "CDFILIAL",
          "NRPEDIDOFOS",
          "NRITPEDIDOFOS",
        ]);
        const novoItPedidoFos = {};

        for (const itPedidoFos of cdsCliItPedidoFos.data) {
          for (const field of fields) {
            if (itPedidoFos[field.name] && field.name === "NRSEQVENDA") {
              const vendaTemp = cdsVendaTemp.locate(
                ["NRSEQANT"],
                [itPedidoFos[field.name]]
              );
              novoItPedidoFos[field.name] = vendaTemp["NRSEQNEW"] || null;
            } else if (
              itPedidoFos[field.name] &&
              field.name === "NRPEDIDOFOS"
            ) {
              const pedidoFosTemp = cdsPedidoFosTemp.locate(
                ["NRSEQANT"],
                [itPedidoFos[field.name]]
              );
              novoItPedidoFos[field.name] = pedidoFosTemp["NRSEQNEW"] || null;
            } else {
              novoItPedidoFos[field.name] = itPedidoFos[field.name] || null;
            }
          }
        }

        await OracleService.execute(insertQuery, novoItPedidoFos);
      } catch (error) {
        console.log(error);
      }
    }
  }

  async verificaReducaoZ(cdsCliReducaoZ) {
    const cdsRetReducaoZ = new ClientDataSet();
    for (const reducaoZ of cdsCliReducaoZ.data) {
      const params = {
        P_CDFILIAL: reducaoZ["CDFILIAL"],
        P_CDCAIXA: reducaoZ["CDCAIXA"],
        P_NRECFREDZ: reducaoZ["NRECFREDZ"],
        P_DTREDUCAOZ: DateFormat(reducaoZ["DTREDUCAOZ"]),
      };

      try {
        const adqVerificaRedZResult = await adqVerificaRedZ.get(params);

        const idSituacao = !adqVerificaRedZResult.rows.length ? "NOK" : "OK";

        const dadosReducaoZ = {
          CDFILIAL: reducaoZ["CDFILIAL"],
          CDCAIXA: reducaoZ["CDCAIXA"],
          DTREDUCAOZ: reducaoZ["DTREDUCAOZ"],
          NRECFREDZ: reducaoZ["NRECFREDZ"],
          IDSITUACAO: idSituacao,
        };

        cdsRetReducaoZ.data.push(dadosReducaoZ);
      } catch (error) {
        console.log(error);
        throw error;
      }
    }

    return cdsRetReducaoZ;
  }

  async editaOperador(dataSetOrigem) {
    try {
      const operadores = dataSetOrigem.data.filter((operador) => {
        return operador["IDATUOPERADOR"] === "A";
      });

      if (operadores.length) {
        const { updateQuery, fields } = await ConstructQuery("OPERADOR", [
          "CDOPERADOR",
        ]);

        const params = [];
        const connection = await OracleService.getNewConnection();

        for (const operador of operadores) {
          // fazer o loop nos campos fields
          fields.forEach((field) => {
            if (field.name === "IDATUOPERADOR") {
              params[field.name] = "S";
            } else if (field.dbTypeName === "DATE") {
              params[field.name] = operador[field.name]
                ? DateFormat(operador[field.name])
                : null;
            } else {
              params[field.name] = operador[field.name];
            }
          });
          await OracleService.execute(updateQuery, params, connection);
        }
        await connection.commit();
      }
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  async verificaOperador(cdsOperador) {
    const cdsRetOperador = new ClientDataSet();
    for (const retOperador of cdsOperador.data) {
      const params = {
        P_CDOPERADOR: retOperador["CDOPERADOR"],
      };
      try {
        const adqSrvUpdOperadorResult = await adqSrvUpdOperador.get(params);

        const idSituacao = adqSrvUpdOperadorResult.rows.length ? "OK" : "NOK";

        const dadosOperador = {
          CDOPERADOR: retOperador["CDOPERADOR"],
          IDSITUACAO: idSituacao,
        };

        cdsRetOperador.data.push(dadosOperador);
      } catch (error) {
        console.log(error);
        throw error;
      }
    }

    return cdsRetOperador;
  }

  async insereControlSenha(cdsCliControlSenha) {
    try {
      const controlesenhas = cdsCliControlSenha.data.filter((controle) => {
        return controle["IDATUCTRLSENHA"] === "I";
      });

      if (controlesenhas.length) {
        const { insertQuery, fields } = await ConstructQuery("CONTROLSENHA", [
          "CDOPERADOR",
          "DTALTSENHA",
          "CDSENHALT",
        ]);

        const params = [];

        for (const controle of controlesenhas) {
          // fazer o loop nos campos fields
          fields.forEach((field) => {
            if (field.name === "IDATUCTRLSENHA") {
              params[field.name] = "S";
            } else if (field.dbTypeName === "DATE") {
              params[field.name] = controle[field.name]
                ? DateFormat(controle[field.name])
                : null;
            } else {
              params[field.name] = controle[field.name];
            }
          });
          await OracleService.execute(insertQuery, params);
        }
        await OracleService.connection.commit();
      }
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  async verificaControlSenha(cdsCliControlSenha) {
    const cdsRetControlSenha = new ClientDataSet();
    for (const retControlSenha of cdsCliControlSenha.data) {
      const params = {
        P_CDOPERADOR: retControlSenha["CDOPERADOR"],
        P_CDSENHALT: retControlSenha["CDSENHALT"],
        P_DTALTSENHA: DateFormat(retControlSenha["DTALTSENHA"]),
      };
      try {
        const adqVerifControlSenhaResult = await adqVerifControlSenha.get(
          params
        );

        const idSituacao = adqVerifControlSenhaResult.rows.length
          ? "OK"
          : "NOK";

        const dadosControleSenha = {
          CDOPERADOR: retControlSenha["CDOPERADOR"],
          CDSENHALT: retControlSenha["CDSENHALT"],
          DTALTSENHA: DateFormat(retControlSenha["DTALTSENHA"]),
          IDSITUACAO: idSituacao,
        };

        cdsRetControlSenha.data.push(dadosControleSenha);
      } catch (error) {
        console.log(error);
        throw error;
      }
    }

    return cdsRetControlSenha;
  }

  async consisteInutilizaNfce(cdsCliINUTILIZANFCE) {
    const promises = cdsCliINUTILIZANFCE.data.map(async (item) => {
      const params = {
        P_CDFILIAL: item["CDFILIAL"],
        P_CDCAIXA: item["CDCAIXA"],
        P_NRNOTAFISCALCE: item["NRNOTAFISCALCE"],
      };
      const queryResult = await adqVerifInutilizaNfce.get(params);

      return queryResult.rows.length ? null : item;
    });
    const mappedCds = await Promise.all(promises);

    return mappedCds.filter((item) => {
      return item;
    });
  }

  async verificaInutilizaNfce(cdsCliINUTILIZANFCE) {
    const cdsRetInutilizaNfce = new ClientDataSet();
    const promises = cdsCliINUTILIZANFCE.data.map(async (item) => {
      const params = {
        P_CDFILIAL: item["CDFILIAL"],
        P_CDCAIXA: item["CDCAIXA"],
        P_NRNOTAFISCALCE: item["NRNOTAFISCALCE"],
      };
      const queryResult = await adqVerifInutilizaNfce.get(params);

      return {
        CDFILIAL: item["CDFILIAL"],
        CDCAIXA: item["CDCAIXA"],
        NRNOTAFISCALCE: item["NRNOTAFISCALCE"],
        IDSITUACAO: queryResult.rows.length ? "OK" : "NOK",
      };
    });

    cdsRetInutilizaNfce.data = await Promise.all(promises);

    return cdsRetInutilizaNfce;
  }

  async apagaNovoCodigoNFCE(cdFilial, cdCaixa, cdsCliNOVOCODNFCE) {
    try {
      // adicionar
      const cdsNovoCodNFCE = new ClientDataSet([]);

      for (const novoCodNFCE of cdsCliNOVOCODNFCE.data) {
        const params = {
          P_CDCONTADOR: novoCodNFCE["CDCONTADOR"],
          P_NRSEQUENCIAL: novoCodNFCE["NRSEQUENCIAL"],
        };
        // prettier-ignore
        const adqSrvUpdOperadorResult = await adqVerificaNOVOCODNFCE.get(params);
        const connection = await OracleService.getNewConnection();
        if (adqSrvUpdOperadorResult.rows.length) {
          await acmDelNOVOCODNFCE.get(params, connection);
          await connection.commit();
          cdsNovoCodNFCE.data.push(cdsCliNOVOCODNFCE);
        }
      }

      /*const params = { P_CDCONTADOR: cdFilial, P_NRSEQUENCIAL: cdCaixa };
      const adqSrvUpdOperadorResult = await adqVerificaNOVOCODNFCE.get(params);

      const connection = await OracleService.getNewConnection();
      if (adqSrvUpdOperadorResult.rows.length) {
        await acmDelNOVOCODNFCE.get(params, connection);
        await connection.commit();
      }*/
    } catch (error) {
      console.log(error);
      throw error;
    }
  }

  async consisteArqCat52(cdsCliArqCat52) {
    const promises = cdsCliArqCat52.data.map(async (item) => {
      const params = {
        P_CDFILIAL: item["CDFILIAL"],
        P_CDCAIXA: item["CDCAIXA"],
        P_NRSERIECAT52: item["NRSERIECAT52"],
        P_DTMOVCAT52: DateFormat(item["DTMOVCAT52"]),
      };
      const queryResult = await adqVerifArqCat52.get(params);

      return queryResult.rows.length ? null : item;
    });
    const mappedCds = await Promise.all(promises);

    return mappedCds.filter((item) => {
      return item;
    });
  }

  async verificaArqCat52(cdsCliArqCat52) {
    const cdsRetArqCat52 = new ClientDataSet();
    const promises = cdsCliArqCat52.data.map(async (item) => {
      const params = {
        P_CDFILIAL: item["CDFILIAL"],
        P_CDCAIXA: item["CDCAIXA"],
        P_NRSERIECAT52: item["NRSERIECAT52"],
        P_DTMOVCAT52: DateFormat(item["DTMOVCAT52"]),
      };
      const queryResult = await adqVerifArqCat52.get(params);

      return {
        CDFILIAL: item["CDFILIAL"],
        CDCAIXA: item["CDCAIXA"],
        NRSERIECAT52: item["NRSERIECAT52"],
        DTMOVCAT52: DateFormat(item["DTMOVCAT52"]),
        IDSITUACAO: queryResult.rows.length ? "OK" : "NOK",
      };
    });

    cdsRetArqCat52.data = await Promise.all(promises);

    return cdsRetArqCat52;
  }

  async gravaArqCat52(cdsCliArqCat52) {
    for (const item of cdsCliArqCat52.data) {
      await this.salvaCat52Servidor(
        item["CDFILIAL"],
        item["CDCAIXA"],
        DateFormat(item["DTMOVCAT52"])
      );
    }
  }

  async salvaCat52Servidor(cdFilial, cdCaixa, dtMovCat52) {
    const params = {
      P_CDFILIAL: cdFilial,
      P_CDCAIXA: cdCaixa,
      P_DATAMOVI: dtMovCat52,
    };

    const queryResult = await adqArqCat52.get(params);

    if (queryResult.rows.length) {
      let dirSalvCat = this.getAdqFieldValue(queryResult, "DSDIRSALVCAT");

      if (dirSalvCat) {
        const date = new Date(dtMovCat52);
        const cdLoja = this.getAdqFieldValue(queryResult, "CDLOJA");
        const ano = date.getFullYear().toString();
        const mes = (date.getMonth() + 1).toString();

        dirSalvCat = path.join(
          dirSalvCat,
          ano,
          mes,
          `${cdFilial}${cdLoja}${cdCaixa}`
        );

        if (!fs.existsSync(dirSalvCat)) {
          fs.mkdirSync(dirSalvCat, { recursive: true });
        }

        try {
          const zip = new admZip();
          const dsArqCat52 = this.getAdqFieldValue(queryResult, "DSARQCAT52");
          const fileContent = String.fromCharCode(...dsArqCat52);
          const fileName = this.getAdqFieldValue(queryResult, "NMARQCAT52");
          zip.addFile(fileName, Buffer.from(fileContent, "utf8"));
          const zipFileName = path.join(
            dirSalvCat,
            `${this.getAdqFieldValue(queryResult, "NMARQCAT52")}.zip`
          );
          zip.writeZip(zipFileName);
        } catch (error) {
          console.log(error);
          throw error;
        }
      }
    }
  }

  async insereEstornoVnd(cdsCliEstornoVnd, cdFilial, cdCaixa) {
    if (cdsCliEstornoVnd.data.length) {
      try {
        const { insertQuery, fields } = await ConstructQuery("ESTORNOVND", [
          "CDFILIAL",
          "CDCAIXA",
          "NRSEQVENDA",
        ]);

        const novoEstornoVnd = {};

        for (const item of cdsCliEstornoVnd.data) {
          const params = {
            P_CDFILIAL: item["CDFILIAL"],
            P_CDCAIXA: item["CDCAIXA"],
            P_DTABERTUR: DateFormat(item["DTABERTUR"]),
            P_NRSEQVENDA: item["NRSEQVENDA"],
          };

          // Se encontrar o NRSEQVENDA correspondente à venda no MSDE
          const verifVendaResult = await adqVerifVenda.get(params);

          if (verifVendaResult.rows.length) {
            const nrSeqVenda = this.getAdqFieldValue(
              verifVendaResult,
              "NRSEQVENDA"
            );
            params["P_NRSEQVENDA"] = nrSeqVenda;
            delete params["P_DTABERTUR"];

            // Verifica se o registro já se encontra no Oracle
            const validaEstornoResult = await adqValidaEstorno.get(params);

            // Se o registro não estiver no Oracle
            if (!validaEstornoResult.rows.length) {
              for (const field of fields) {
                if (field.name === "NRSEQVENDA") {
                  novoEstornoVnd[field.name] = nrSeqVenda;
                } else if (field.name === "DTABERTUR") {
                  // Não será inserido na ESTORNOVND, pois trata-se de um campo da tabela VENDA
                } else if (!field.name) {
                  novoEstornoVnd[field.name] = null;
                } else {
                  novoEstornoVnd[field.name] = item[field.name];
                }
              }

              await OracleService.execute(insertQuery, novoEstornoVnd);
            }
          }
        }
      } catch (error) {
        InfoLogger.write(
          `${cdFilial} ${cdCaixa} InsereEstornoVnd exception: ${error}`,
          cdFilial
        );
        console.log(error);
        throw error;
      }
    }
  }

  async verificaEstornoVnd(cdsCliEstornoVnd) {
    const cdsRetEstornoVnd = new ClientDataSet();
    const promises = cdsCliEstornoVnd.data.map(async (item) => {
      const params = {
        P_CDFILIAL: item["CDFILIAL"],
        P_CDCAIXA: item["CDCAIXA"],
        P_DTABERTUR: DateFormat(item["DTABERTUR"]),
        P_NRSEQVENDA: item["NRSEQVENDA"],
      };
      const verifVendaResult = await adqVerifVenda.get(params);
      params["P_NRSEQVENDA"] = this.getAdqFieldValue(
        verifVendaResult,
        "NRSEQVENDA"
      );
      delete params["P_DTABERTUR"];
      const validaEstornoResult = await adqValidaEstorno.get(params);

      return {
        CDFILIAL: item["CDFILIAL"],
        CDCAIXA: item["CDCAIXA"],
        NRSEQVENDA: item["NRSEQVENDA"],
        IDSITUACAO: validaEstornoResult.rows.length ? "OK" : "NOK",
      };
    });

    cdsRetEstornoVnd.data = await Promise.all(promises);

    return cdsRetEstornoVnd;
  }

  async verificaLogSincDlv(cdsCliLogSincDlv) {
    const cdsRetLogSincDlv = new ClientDataSet();
    for (const cliLogSincDlv of cdsCliLogSincDlv.data) {
      const params = {
        P_CDFILIAL: cliLogSincDlv["CDFILIAL"],
        P_CDLOJA: cliLogSincDlv["CDLOJA"],
        P_DTHRABERMESA: DateFormat(cliLogSincDlv["DTHRABERMESA"]),
        P_NRVENDARESTAUX: cliLogSincDlv["NRVENDARESTAUX"],
      };

      const verifLogSincDlvResult = await adqVerifLogSincDlv.get(params);

      const idSituacao = verifLogSincDlvResult.rows.length ? "OK" : "NOK";

      const dadosLogSincDlv = {
        CDFILIAL: cliLogSincDlv["CDFILIAL"],
        CDLOJA: cliLogSincDlv["CDLOJA"],
        NRVENDARESTAUX: cliLogSincDlv["NRVENDARESTAUX"],
        DTHRABERMESA: DateFormat(cliLogSincDlv["DTHRABERMESA"]),
        IDSITUACAO: idSituacao,
      };

      cdsRetLogSincDlv.data.push(dadosLogSincDlv);
    }
    return cdsRetLogSincDlv;
  }

  async consisteLogSincDlv(cdsCliLogSincDlv) {
    try {
      const promises = cdsCliLogSincDlv.data.map(async (item) => {
        const params = {
          P_CDFILIAL: item["CDFILIAL"],
          P_CDLOJA: item["CDLOJA"],
          P_DTHRABERMESA: DateFormat(item["DTHRABERMESA"]),
          P_NRVENDARESTAUX: item["NRVENDARESTAUX"],
        };
        const queryResult = await adqVerifLogSincDlv.get(params);

        return queryResult.rows.length ? null : item;
      });
      const mappedCds = await Promise.all(promises);

      return mappedCds.filter((item) => {
        return item;
      });
    } catch (error) {
      console.log(error);
    }
  }

  async consisteControlSenha(cdsCliControlSenha) {
    const promises = cdsCliControlSenha.data.map(async (item) => {
      const params = {
        P_CDOPERADOR: item["CDOPERADOR"],
        P_CDSENHALT: item["CDSENHALT"],
        P_DTALTSENHA: DateFormat(item["DTALTSENHA"]),
      };

      const queryResult = await adqVerifControlSenha.get(params);

      return queryResult.rows.length ? null : item;
    });
    const mappedCds = await Promise.all(promises);

    return mappedCds.filter((item) => {
      return item;
    });
  }

  async atualizaMovBeneficioCtr(
    cdsCliMovBeneficioCtr,
    cdsCliMovBeneficioCons,
    cdsCliVenda,
    cdFilial,
    cdCaixa
  ) {
    try {
      const connection = await OracleService.getNewConnection();
      for (const cliMovBeneficioCtr of cdsCliMovBeneficioCtr.data) {
        const params = {
          P_CDCLIENTE: cliMovBeneficioCtr["CDCLIENTE"],
          P_CDCONSUMIDOR: cliMovBeneficioCtr["CDCONSUMIDOR"],
          P_CDCAMPANHA: cliMovBeneficioCtr["CDCAMPANHA"],
          P_NRSEQPRODCAMP: cliMovBeneficioCtr["NRSEQPRODCAMP"],
          P_NRSEQBENEFICIO: cliMovBeneficioCtr["NRSEQBENEFICIO"],
        };

        const adqVerifMovBeneficioCtrResult = await adqVerifMovBeneficioCtr.get(
          params
        );

        if (adqVerifMovBeneficioCtrResult.rows.length) {
          const beneficios = cdsCliMovBeneficioCons.data.filter((beneficio) => {
            return (
              beneficio["CDCLIENTE"] === cliMovBeneficioCtr["CDCLIENTE"] &&
              beneficio["CDCONSUMIDOR"] ===
                cliMovBeneficioCtr["CDCONSUMIDOR"] &&
              beneficio["CDCAMPANHA"] === cliMovBeneficioCtr["CDCAMPANHA"] &&
              beneficio["NRSEQPRODCAMP"] ===
                cliMovBeneficioCtr["NRSEQPRODCAMP"] &&
              beneficio["NRSEQBENEFICIO"] ===
                cliMovBeneficioCtr["NRSEQBENEFICIO"]
            );
          });

          for (const beneficio of beneficios) {
            const vendas = cdsCliVenda.data.filter((venda) => {
              return (
                venda["CDFILIAL"] === beneficio["CDFILIAL"] &&
                venda["CDCAIXA"] === beneficio["CDCAIXA"] &&
                venda["NRSEQVENDA"] === beneficio["NRSEQVENDA"]
              );
            });

            if (vendas["IDSITUVENDA"] === "O") {
              const parametros = {
                P_CDCLIENTE: vendas["CDCLIENTE"],
                P_CDCONSUMIDOR: vendas["CDCONSUMIDOR"],
                P_CDCAMPANHA: vendas["CDCAMPANHA"],
                P_NRSEQPRODCAMP: vendas["NRSEQPRODCAMP"],
                P_NRSEQBENEFICIO: vendas["NRSEQBENEFICIO"],
              };
              await acmUpdMovBeneficioCtr.get(parametros, connection);
            }
          }
          await connection.commit();
        } else {
          const { insertQuery, fields } = await ConstructQuery(
            "MOVBENEFICIOCTR"
          );
          const novoBeneficio = {};

          for (const cliBeneficioCtr of cdsCliMovBeneficioCtr.data) {
            fields.forEach((field) => {
              if (field.name === "IDIMPTMOVCTR") {
                novoBeneficio[field.name] = "N";
              } else if (field.dbTypeName === "DATE") {
                novoBeneficio[field.name] = cliBeneficioCtr[field.name]
                  ? DateFormat(cliBeneficioCtr[field.name])
                  : null;
              } else {
                novoBeneficio[field.name] = cliBeneficioCtr[field.name];
              }
            });
            await OracleService.execute(
              insertQuery,
              novoBeneficio,
              [],
              connection
            );
          }
          await connection.commit();
        }
      }
    } catch (error) {
      console.log(error);
      InfoLogger.write(
        `${cdFilial} ${cdCaixa} AtualizaMovBeneficioCtr exception: ${error}`,
        cdFilial
      );
    }
  }

  async verificaMovBeneCtr(cdsCliMovBeneficioCons) {
    const cdsRetMovBeneCtr = new ClientDataSet();

    for (const cliMovBeneficioCons of cdsCliMovBeneficioCons.data) {
      const params = {
        P_CDCLIENTE: cliMovBeneficioCons["CDCLIENTE"],
        P_CDCONSUMIDOR: cliMovBeneficioCons["CDCONSUMIDOR"],
        P_CDCAMPANHA: cliMovBeneficioCons["CDCAMPANHA"],
        P_NRSEQPRODCAMP: cliMovBeneficioCons["NRSEQPRODCAMP"],
        P_NRSEQBENEFICIO: cliMovBeneficioCons["NRSEQBENEFICIO"],
      };

      const MovBeneCtrResult = await adqVerifMovBeneficioCtr.get(params);
      // prettier-ignore
      const idSituacao = this.getAdqFieldValue(MovBeneCtrResult, 'QTDEBENEFICIO') === cliMovBeneficioCons['QTDEBENEFICIO'] ? 'OK' : 'NOK';
      const dadosMovBeneCtr = {
        CDCLIENTE: cliMovBeneficioCons["CDCLIENTE"],
        CDCONSUMIDOR: cliMovBeneficioCons["CDCONSUMIDOR"],
        CDCAMPANHA: cliMovBeneficioCons["CDCAMPANHA"],
        NRSEQPRODCAMP: cliMovBeneficioCons["NRSEQPRODCAMP"],
        NRSEQBENEFICIO: cliMovBeneficioCons["NRSEQBENEFICIO"],
        IDSITUACAO: idSituacao,
        QTDEBENEFICIO: this.getAdqFieldValue(MovBeneCtrResult, "QTDEBENEFICIO"),
      };

      cdsRetMovBeneCtr.data.push(dadosMovBeneCtr);
    }

    return cdsRetMovBeneCtr;
  }

  async consisteItComandaPend(cdFilial, cdLoja, cdsCliItComandaPend) {
    // let naoDeletar = ' ';
    // let cliItComandaPend = cdsCliItComandaPend;
    if (cdsCliItComandaPend.data.length) {
      for (let i = 0; i < cdsCliItComandaPend.data.length; i++) {
        const item = cdsCliItComandaPend.data[i];

        const params = {
          P_CDFILIAL: item["CDFILIAL"],
          P_CDLOJA: item["CDLOJA"],
          P_NRVENDARESTPEND: item["NRVENDARESTPEND"],
          P_NRCOMANDAPEND: item["NRCOMANDAPEND"],
          P_NRPRODCOMVENPEN: item["NRPRODCOMVENPEN"],
          P_QTPRODCOMVENPEN: item["QTPRODCOMVENPEN"],
        };

        try {
          const verifComandaPend = await adqVerifItComandaPend.get(params);

          if (verifComandaPend.rows.length) {
            const naoDeletar = `${item["CDFILIAL"]}${item["CDLOJA"]}${item["NRVENDARESTPEND"]}${item["NRCOMANDAPEND"]}${item["NRPRODCOMVENPEN"]}_`;

            let indice = cdsCliItComandaPend.data.findIndex(
              (itComanda) =>
                itComanda.CDFILIAL === item["CDFILIAL"] &&
                itComanda.CDLOJA === item["CDLOJA"] &&
                itComanda.NRVENDARESTPEND === item["NRVENDARESTPEND"] &&
                itComanda.NRCOMANDAPEND === item["NRCOMANDAPEND"] &&
                itComanda.NRPRODCOMVENPEN === item["NRPRODCOMVENPEN"]
            );

            cdsCliItComandaPend.data.splice(indice, 1);
            i--;
            const params = {
              P_NAODELETA: naoDeletar,
              P_FILILOJA: `${cdFilial}${cdLoja}`,
            };

            const connection = await OracleService.getNewConnection();
            await acmDelItComandaPend.get(params, connection);
            await connection.commit();
          }
        } catch (error) {
          console.log(error);
        }
      }
    }
  }

  async consisteReducaoZ(
    cdsCliReducaoZ,
    cdsCliImpostoRedZ,
    cdsCliTotNfiscRedZ,
    cdsCliFormPgtoRedZ
  ) {
    let cdsRedZ = new ClientDataSet([]);

    for (const cliReducaoZ of cdsCliReducaoZ.data) {
      const params = {
        P_CDFILIAL: cliReducaoZ["CDFILIAL"],
        P_CDCAIXA: cliReducaoZ["CDCAIXA"],
        P_NRECFREDZ: cliReducaoZ["NRECFREDZ"],
        P_DTREDUCAOZ: DateFormat(cliReducaoZ["DTREDUCAOZ"]),
      };

      const verificaRedZ = await adqVerificaRedZ.get(params);

      if (verificaRedZ.rows.length) {
        const impostoRedZ = cdsCliImpostoRedZ.data.filter((impostos) => {
          return (
            impostos["CDFILIAL"] !== cliReducaoZ["CDFILIAL"] ||
            impostos["CDCAIXA"] !== cliReducaoZ["CDCAIXA"] ||
            DateFormat(impostos["DTREDUCAOZ"]) !==
              DateFormat(cliReducaoZ["DTREDUCAOZ"]) ||
            impostos["NRECFREDZ"] !== cliReducaoZ["NRECFREDZ"]
          );
        });

        cdsCliImpostoRedZ.data = impostoRedZ;

        const cliTotNfiscRedZ = cdsCliTotNfiscRedZ.data.filter((notaFisc) => {
          return (
            notaFisc["CDFILIAL"] !== cliReducaoZ["CDFILIAL"] ||
            notaFisc["CDCAIXA"] !== cliReducaoZ["CDCAIXA"] ||
            DateFormat(notaFisc["DTREDUCAOZ"]) !==
              DateFormat(cliReducaoZ["DTREDUCAOZ"]) ||
            notaFisc["NRECFREDZ"] !== cliReducaoZ["NRECFREDZ"]
          );
        });

        cdsCliTotNfiscRedZ.data = cliTotNfiscRedZ;

        const cliFormPgtoRedZ = cdsCliFormPgtoRedZ.data.filter((formPgto) => {
          return (
            formPgto["CDFILIAL"] !== cliReducaoZ["CDFILIAL"] ||
            formPgto["CDCAIXA"] !== cliReducaoZ["CDCAIXA"] ||
            DateFormat(formPgto["DTREDUCAOZ"]) !==
              DateFormat(cliReducaoZ["DTREDUCAOZ"]) ||
            formPgto["NRECFREDZ"] !== cliReducaoZ["NRECFREDZ"]
          );
        });

        cdsCliFormPgtoRedZ.data = cliFormPgtoRedZ;
      } else {
        cdsRedZ.data.push(cliReducaoZ);
      }
    }
    cdsCliReducaoZ.data = cdsRedZ.data;
  }

  async verificaTotalDiaCaixa(cdsCliTotalDiaCaixa) {
    const cdsRetTotalDiaCaixa = new ClientDataSet([]);

    for (const totalDiaCaixa of cdsCliTotalDiaCaixa.data) {
      const params = {
        P_CDFILIAL: totalDiaCaixa["CDFILIAL"],
        P_CDCAIXA: totalDiaCaixa["CDCAIXA"],
        P_DTTOTAL: DateFormat(totalDiaCaixa["DTTOTAL"]),
      };

      const adqVerifTotalDiaCaixaSincResult =
        await adqVerifTotalDiaCaixaSinc.get(params);
      const idSituacao = adqVerifTotalDiaCaixaSincResult.rows.length
        ? "OK"
        : "NOK";

      cdsRetTotalDiaCaixa.data.push({
        CDFILIAL: totalDiaCaixa["CDFILIAL"],
        CDCAIXA: totalDiaCaixa["CDCAIXA"],
        DTTOTAL: DateFormat(totalDiaCaixa["DTTOTAL"]),
        IDSITUACAO: idSituacao,
      });
    }

    return cdsRetTotalDiaCaixa;
  }

  async ConsisteEndeCons(cdsCliEndeCons, cdFilial) {
    if (cdsCliEndeCons.data.length) {
      let cliEndCons = new ClientDataSet([]);
      for (let i = 0; i < cdsCliEndeCons.data.length; i++) {
        const item = cdsCliEndeCons.data[i];

        const params = {
          P_CDCLIENTE: item["CDCLIENTE"],
          P_CDCONSUMIDOR: item["CDCONSUMIDOR"],
          P_CDENDECONS: item["CDENDECONS"],
        };

        const adqVerifEndeConsResult = await adqVerifEndeCons.get(params);
        if (adqVerifEndeConsResult.rows.length) {
          let indice = cdsCliEndeCons.data.findIndex(
            (endCons) =>
              endCons.CDCLIENTE === item["CDCLIENTE"] &&
              endCons.CDCONSUMIDOR === item["CDCONSUMIDOR"] &&
              endCons.CDENDECONS === item["CDENDECONS"]
          );

          InfoLogger.write(
            `Código do endereço do consumidor já cadastrado no Retaguarda. CDCLIENTE: ${item["CDFILIAL"]} CDCONSUMIDOR: ${item["CDCONSUMIDOR"]} CDENDECONS: ${item["CDENDECONS"]}`,
            cdFilial
          );
          cdsCliEndeCons.data.splice(indice, 1);
          i--;
        } else {
          cliEndCons.data.push(item);
        }
      }
      cdsCliEndeCons = cliEndCons;
    }
  }

  async VerificaProdBloqVndTaa(cdsCliProdBloqVndTaa) {
    const cdsRetProdBloqVndTaa = new ClientDataSet([]);

    for (const prodBloqVndTaa of cdsCliProdBloqVndTaa.data) {
      const params = {
        P_CDFILIAL: prodBloqVndTaa["CDFILIAL"],
        P_CDLOJA: prodBloqVndTaa["CDLOJA"],
        P_CDPRODUTO: prodBloqVndTaa["CDPRODUTO"],
        P_NRDIASEMANABLOQ: prodBloqVndTaa["NRDIASEMANABLOQ"],
      };

      const adqVerifProdBloqVndTaaResult = await adqVerifProdBloqVndTaa.get(
        params
      );
      const idSituacao = adqVerifProdBloqVndTaaResult.rows.length
        ? "OK"
        : "NOK";

      cdsRetProdBloqVndTaa.data.push({
        CDFILIAL: prodBloqVndTaa["CDFILIAL"],
        CDCAIXA: prodBloqVndTaa["CDLOJA"],
        CDPRODUTO: prodBloqVndTaa["CDPRODUTO"],
        NRDIASEMANABLOQ: prodBloqVndTaa["NRDIASEMANABLOQ"],
        IDSITUACAO: idSituacao,
      });
    }

    return cdsRetProdBloqVndTaa;
  }

  async VerificaEndeCons(cdsCliEndeCons) {
    const cdsRetEndeCons = new ClientDataSet([]);

    for (const endeCons of cdsCliEndeCons.data) {
      const params = {
        P_CDCLIENTE: endeCons["CDCLIENTE"],
        P_CDCONSUMIDOR: endeCons["CDCONSUMIDOR"],
        P_CDENDECONS: endeCons["CDENDECONS"],
      };

      const adqVerifEndeConsResult = await adqVerifEndeCons.get(params);
      const idSituacao = adqVerifEndeConsResult.rows.length ? "OK" : "NOK";

      cdsRetEndeCons.data.push({
        CDCLIENTE: endeCons["CDCLIENTE"],
        CDCONSUMIDOR: endeCons["CDCONSUMIDOR"],
        CDENDECONS: endeCons["CDENDECONS"],
        IDSITUACAO: idSituacao,
      });
    }

    return cdsRetEndeCons;
  }

  async VerificaLogNfce(cdsCliLogNfce) {
    const cdsRetLogNfce = new ClientDataSet([]);

    for (const logNfce of cdsCliLogNfce.data) {
      const params = {
        P_CDFILIAL: logNfce["CDFILIAL"],
        P_CDCAIXA: logNfce["CDCAIXA"],
        P_NRSEQVENDA: logNfce["NRSEQVENDA"],
        P_DTABERTUR: logNfce["DTABERTUR"],
        P_NRSEQLOGNFCE: logNfce["NRSEQLOGNFCE"],
      };

      const adqVerifLogNfceResult = await adqVerifLogNfce.get(params);
      const idSituacao = adqVerifLogNfceResult.rows.length ? "OK" : "NOK";

      cdsRetLogNfce.data.push({
        CDFILIAL: logNfce["CDFILIAL"],
        CDCAIXA: logNfce["CDCAIXA"],
        NRSEQVENDA: logNfce["NRSEQVENDA"],
        NRSEQLOGNFCE: logNfce["NRSEQLOGNFCE"],
        IDSITUACAO: idSituacao,
      });
    }

    return cdsRetLogNfce;
  }
}

module.exports = new UpDataService();
