import { ComponentRender } from '@zeedhi/common';
import { IModalLog, IModalLogEvents } from './interfaces';

export class ModalLog extends ComponentRender implements IModalLog {
    public text?: string = '';

    public rows?: string | number = 20;

    public events!: IModalLogEvents;

    constructor(props: IModalLog) {
        super(props);
        this.text = this.getInitValue('text', props.text, this.text);
        this.rows = this.getInitValue('rows', props.rows, this.rows);
        this.createAccessors();
    }

    public clearText() {
        this.text = '';
    }

    public getText(): string {
        return this.text || '';
    }

    public setText(text: string) {
        this.text = text;
    }

    public addText(text: string, previousText: string = '', laterText: string = '\n'): void {
        this.text = `${this.text}${previousText}${text}${laterText}`;
    }
}
