class DataSourceHelper {
    private getGridData(grid: any, dataset?: Array<any>) {
        const mainGrid = grid;
        const { resultData } = mainGrid.datasource;
        return dataset || resultData;
    }

    private matchItem(pkValue: Array<any> | string, valueToCompare: any) {
        if (Array.isArray(pkValue)) {
            return pkValue.includes(valueToCompare.toString());
        }
        return pkValue.toString() === valueToCompare.toString();
    }

    public updateGridRow(grid: any, pkName: string, pkValue: Array<any> | string, newValues: object, dataset?: Array<any>) {
        const data = this.getGridData(grid, dataset);

        if (!data || !data.length) return;
        let foundItem = false;
        const updatedRows = [];
        for (let i = 0; i < data.length; i += 1) {
            const row = data[i];
            if (row[pkName] && this.matchItem(pkValue, row[pkName])) {
                Object.assign(row, newValues);
                updatedRows.push(row);
                foundItem = true;
            } else if (foundItem) {
                break;
            }
        }
        const hasGroupedColumn = grid.columns.find((column: any) => column.grouped);
        if (hasGroupedColumn) {
            grid.buildGroupedData();
        }
        return updatedRows;
    }
}
export default new DataSourceHelper();
