class MessageHandler {
    message: any = {
        CONNECTION_ACTIVE_REQUIRED_CHANGE_CONFIG: 'A conexão deve estar ativa para configurar o Config.ini.',
        CONNECTION_ACTIVE_REQUIRED_TEST_DB: 'A conexão deve estar ativa para realizar o teste de conexão com a base de dados.',
        CONNECTION_ACTIVE_REQUIRED_UPDATE_CONFIG_FILE_UNIT: 'Arquivo de configuração não pode ser atualizado na loja. Não existe conexão ativa com a loja no momento.',
        CONNECTION_ACTIVE_REQUIRED_UNIT: 'A conexão com a unidade deve estar ativa para realizar esta ação.',
        DEFAULT_MESSAGE_NOT_FOUND: 'A mensagem ou o código da mensagem enviado não é valido.',
        DUPLICATE_CONNECTION_ATTEMPT: 'Foi realizada uma tentativa de conexão da mesma unidade em outra instalação.',
        FAIL_FORM_VALIDATION: 'Falha na validação do formulário. Favor preencher corretamente todos os campos obrigatórios.',
        FAIL_LOAD_CONFIG_INI: 'Falha ao carregar os dados do arquivo de configuração.',
        FAIL_SAVE_CONFIG_INI_HISTORY: 'Falha ao salvar o histórico para o arquivo de configuração da filial.',
        INCOMPATIBLE_ASSISTANT_VERSION: 'A versão atual do Assistant Updater não é compatível.',
        INVALID_COMMAND_QUERY: 'Consulta inválida. Verifique o campo "Comando" e tente novamente.',
        MAX_CHARACTER_REACHED_COMMAND: 'A quantidade de caracteres do comando excede o limite máximo de 4000 caracteres',
        NO_CONFIG_FILE_FOR_SPECIFIC_UNIT: 'Não existe registro de um arquivo de configuração para a filial __CDFILIAL__',
        NO_DATA_TO_SAVE: 'Não há dados para salvar.',
        REQUIRED_RECORD_TYPE: 'Informe o tipo de registro.',
        REQUIRED_COMMAND: 'Informe o comando.',
        SUCCESS_DELETE_RECORD: 'Registros removidos com sucesso!',
        SUCCESS_INSERT_RECORD: 'Registro inserido com sucesso!',
        SUCCESS_UPDATE_RECORD: 'Registro atualizado com sucesso!',
        SUCCESS_TEST_DB_CONNECTION: 'Teste de conexão efetuado com sucesso!',
        SUCCESS_SYNC_CONFIG_INI: 'Arquivo de configuração sincronizado com sucesso.',
        SUCCESS_LOAD_CONFIG_INI: 'Arquivo de configuração carregado com sucesso!',
        SUCCESS_LOAD_UPDATE_HISTORY_CONFIG: 'Histórico de atualização do arquivo de configuração carregado com sucesso!',
        UNEXPECTED_ERROR: 'Ocorreu um erro inesperado durante a execução da última operação',
        SELECT_UNITS_TO_INSTALL: 'Selecione as filiais que deseja realizar a instalação.',
        REQUEST_INSTALLATION_UPDATE_SUCCESS: 'Requisição de instalação/atualização enviada com sucesso!',
        ERROR_RUNNING_LAST_PROCESS_CHECK_HISTORY_INFORMATION: 'Ocorreu um erro durante a execução do último processo. Verifique o histórico para mais informações.',
        OPERATION_COMPLETED_SUCCESSFULLY: 'Operação finalizada com sucesso!',
        PAGE_WILL_RELOAD_TO_ESTABLISH_CONNECTION: 'A página será recarregada para restabelecer a conexão...',
        ERROR_UPDATING_SYSTEM_LIST: 'Erro ao atualizar a lista de sistemas __ERROR__',
        LIST_OF_SYSTEMS_UPDATE_SUCCESSFULLY: 'Lista de sistemas atualizada com sucesso!',
        ERROR_GET_UNITS: 'Error ao efetuar busca das Filiais.',
        THIS_VERSION_NOT_AVAILABLE_DOWNLOAD: 'Essa versão ainda não está disponível para download. Aguarde alguns instantes e tente novamente',
        CLOUD_VERSION_DOWNLOAD_ERROR: 'Ocorreu um erro ao realizar o download dessa versão para a nuvem. Atualize a lista de sistemas, aguarde alguns instantes e tente novamente.',
        REMOVAL_REQUEST_SUCCESSFULLY: 'Requisição de remoção enviada com sucesso!',
        SYSTEM_LOGGED_EVENT: 'O evento já foi registrado no sistema.',
        EVENT_REGISTERED_SUCCESSFULLY: 'Evento cadastrado com sucesso.',
        SYSTEM_NOT_INSTALLED: 'Sistema não instalado',
        SELECT_VERSION: 'Selecione a versão',
        INSTALLED_VERSION: 'Essa versão já está instalada.',
        FAIL_TEST_DB_CONNECTION: 'Falha no teste de conexão. Erro: __ERROR__',
        DISCONNECTED_SOCKET: 'Ocorreu um erro na conexão com o servidor. Realizando tentativa de reconexão.',
        CONNECTED_SOCKET: 'Conexão com o servidor estabelecida com sucesso',
        DOWNLOAD_IN_PROGRESS: 'Download em progresso...',
        DOWNLOAD_DIRECTORY_NOT_FOUND: 'Diretório de download não encontrado.',
        LOGS_DIRECTORY_NOT_FOUND: 'Diretório de logs não encontrado.',
        TMP_DIRECTORY_NOT_FOUND: 'Diretório temporário não encontrado.',
        UNABLE_TO_READ_THE_FILE: 'Ocorreu um erro ao ler o arquivo.',
        SERVICE_UPDATED_SUCCESS: 'Serviço reiniciado com sucesso.',
        ERROR_UPDATE_SERVICE: 'Erro ao atualizar o serviço __NMSERVICE__.',
        PROCESS_REQUEST: 'Processando solicitação...',
        POPUP_BLOCKER: 'Bloqueador de Pop-up está ativado! Adicione este site à sua lista de exceções.',
        DOWNLOAD_REQUEST_IN_PROGRESS: 'Requisição para download de logs enviada com sucesso.',
        TITLE_CONFIRM_RESTART_DEPENDENT_SERVICES: 'Atenção, os serviços abaixo são dependentes do serviço selecionado',
        CONFIRM_RESTART_SERVICES: 'Deseja realmente reiniciar esses serviços?',
    };

    public getMessageByCode(code: string, params?: any) {
        let message: string = this.message.DEFAULT_MESSAGE_NOT_FOUND;

        if (code) {
            message = this.message[code] || code;
        }

        if (params) {
            const mnemonicArray = this.getMnemonicArray(message);

            mnemonicArray.forEach((mnemonic) => {
                const key = this.removeUnderscore(mnemonic);
                message = message.replace(new RegExp(mnemonic, 'g'), params[key]);
            });
        }

        return message;
    }

    private getMnemonicArray(string: string) {
        const regex = /__\w+__/gi;
        const matches = string.match(regex) || [];
        const uniqueMatches = [...new Set(matches)];

        return uniqueMatches;
    }

    private removeUnderscore(string: string) {
        const regex = /_/g;

        return string.replace(regex, '');
    }
}

export default new MessageHandler();
