CREATE TABLE ASSISTANT_CONFIG (
    ID        NUMBER NOT NULL,
    NOME      VARCHAR2(500) NOT NULL,
    DESCRICAO VARCHAR2(500) NOT NULL,
    TIPO      VARCHAR2(1) NOT NULL,
    COMPLEMENTOTIPO VARCHAR2(1) NOT NULL DEFAULT 'N', 
    ORDEM     NUMBER DEFAULT 1 NOT NULL,
    INTERVALO NUMBER NOT NULL,
    ATIVO     VARCHAR2(1) DEFAULT 'S' NOT NULL,
    COMANDO   VARCHAR2(4000),
    NRORG           NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL,
    DTINCLUSAO        DATE DEFAULT SYSDATE,
    DTULTATU          DATE DEFAULT SYSDATE,
    NRORGINCLUSAO   NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL,
    NRORGULTATU     NUMBER DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NULL
)
/
CREATE SEQUENCE SEQ_ASSISTANT_CONFIG START WITH 1 MINVALUE 1 INCREMENT BY 1
/
CREATE OR REPLACE TRIGGER GERA_ID_ASSISTANT_CONFIG
BEFORE INSERT ON ASSISTANT_CONFIG FOR EACH ROW
BEGIN
  SELECT SEQ_ASSISTANT_CONFIG.NEXTVAL
    INTO :NEW.ID
    FROM DUAL;
END;
/
INSERT INTO ASSISTANT_CONFIG (NOME, DESCRICAO, TIPO, ORDEM, ATIVO, COMANDO, INTERVALO)
                      VALUES ('SAT', 'Monitoramento do SAT', 'I', 1, 'S', 'INTERNO', 60)
/
INSERT INTO ASSISTANT_CONFIG (NOME, DESCRICAO, TIPO, ORDEM, ATIVO, COMANDO, INTERVALO)
                      VALUES ('Serviços Updater', 'Monitoramento de Serviços do Updater', 'I', 1, 'S', 'INTERNO', 60)
/
COMMIT